/*
	FUNZIONI DI POSIZIONAMENTO
*/

// -- POSITIONINFO--
function positionInfo(object) {

  var p_elm = object;

  this.getElementLeft = getElementLeft;
  function getElementLeft() {
    var x = 0;
    var elm;
    if(typeof(p_elm) == "object"){
      elm = p_elm;
    } else {
      elm = document.getElementById(p_elm);
    }
    while (elm != null) {
      x+= elm.offsetLeft;
      elm = elm.offsetParent;
    }
    return parseInt(x);
  }

  this.getElementWidth = getElementWidth;
  function getElementWidth(){
    var elm;
    if(typeof(p_elm) == "object"){
      elm = p_elm;
    } else {
      elm = document.getElementById(p_elm);
    }
    return parseInt(elm.offsetWidth);
  }

  this.getElementRight = getElementRight;
  function getElementRight(){
    return getElementLeft(p_elm) + getElementWidth(p_elm);
  }

  this.getElementTop = getElementTop;
  function getElementTop() {
    var y = 0;
    var elm;
    if(typeof(p_elm) == "object"){
      elm = p_elm;
    } else {
      elm = document.getElementById(p_elm);
    }
    while (elm != null) {
      y+= elm.offsetTop;
      elm = elm.offsetParent;
    }
    return parseInt(y);
  }

  this.getElementHeight = getElementHeight;
  function getElementHeight(){
    var elm;
    if(typeof(p_elm) == "object"){
      elm = p_elm;
    } else {
      elm = document.getElementById(p_elm);
    }
    return parseInt(elm.offsetHeight);
  }

  this.getElementBottom = getElementBottom;
  function getElementBottom(){
    return getElementTop(p_elm) + getElementHeight(p_elm);
  }
}

/*
	CALENDARIO
*/

// --CALENDAR CONTROL--
function CalendarControl() {

  var calendarId = 'CalendarControl';
  var currentYear = 0;
  var currentMonth = 0;
  var currentDay = 0;

  var selectedYear = 0;
  var selectedMonth = 0;
  var selectedDay = 0;

  var months = ['January','February','March','April','May','June','July','August','September','October','November','December'];
  var dateField = null;

  function getProperty(p_property){
    var p_elm = calendarId;
    var elm = null;

    if(typeof(p_elm) == "object"){
      elm = p_elm;
    } else {
      elm = document.getElementById(p_elm);
    }
    if (elm != null){
      if(elm.style){
        elm = elm.style;
        if(elm[p_property]){
          return elm[p_property];
        } else {
          return null;
        }
      } else {
        return null;
      }
    }
  }

  function setElementProperty(p_property, p_value, p_elmId){
    var p_elm = p_elmId;
    var elm = null;

    if(typeof(p_elm) == "object"){
      elm = p_elm;
    } else {
      elm = document.getElementById(p_elm);
    }
    if((elm != null) && (elm.style != null)){
      elm = elm.style;
      elm[ p_property ] = p_value;
    }
  }

  function setProperty(p_property, p_value) {
    setElementProperty(p_property, p_value, calendarId);
  }

  function getDaysInMonth(year, month) {
    return [31,((!(year % 4 ) && ( (year % 100 ) || !( year % 400 ) ))?29:28),31,30,31,30,31,31,30,31,30,31][month-1];
  }

  function getDayOfWeek(year, month, day) {
    var date = new Date(year,month-1,day)
    return date.getDay();
  }

  this.setDate = setDate;
  function setDate(year, month, day) {
    if (dateField) {
      if (month < 10) {month = "0" + month;}
      if (day < 10) {day = "0" + day;}

      //var dateString = month+"-"+day+"-"+year;
      var dateString = year+"-"+month+"-"+day;
      dateField.value = dateString;
      hide();
    }
    return;
  }
  
  this.clearText = clearText;
  function clearText() {
    if (dateField) {
      dateField.value = "";
      hide();
    }
    return;
  }

  this.changeMonth = changeMonth;
  function changeMonth(change) {
    currentMonth += change;
    currentDay = 0;
    if(currentMonth > 12) {
      currentMonth = 1;
      currentYear++;
    } else if(currentMonth < 1) {
      currentMonth = 12;
      currentYear--;
    }

    calendar = document.getElementById(calendarId);
    calendar.innerHTML = calendarDrawTable();
  }

  this.changeYear = changeYear;
  function changeYear(change) {
    currentYear += change;
    currentDay = 0;
    calendar = document.getElementById(calendarId);
    calendar.innerHTML = calendarDrawTable();
  }

  function getCurrentYear() {
    var year = new Date().getYear();
    if(year < 1900) year += 1900;
    return year;
  }

  function getCurrentMonth() {
    return new Date().getMonth() + 1;
  } 

  function getCurrentDay() {
    return new Date().getDate();
  }

  function calendarDrawTable() {

    var dayOfMonth = 1;
    var validDay = 0;
    var startDayOfWeek = getDayOfWeek(currentYear, currentMonth, dayOfMonth);
    var daysInMonth = getDaysInMonth(currentYear, currentMonth);
    var css_class = null; //CSS class for each day

    var table = "<table cellspacing='0' cellpadding='0' border='0'>";
    table = table + "<tr class='header'>";
    table = table + "  <td colspan='2' class='previous'><a href='javascript:changeCalendarControlMonth(-1);'>&lt;</a> <a href='javascript:changeCalendarControlYear(-1);'>&laquo;</a></td>";
    table = table + "  <td colspan='3' class='title'>" + months[currentMonth-1] + "<br>" + currentYear + "</td>";
    table = table + "  <td colspan='2' class='next'><a href='javascript:changeCalendarControlYear(1);'>&raquo;</a> <a href='javascript:changeCalendarControlMonth(1);'>&gt;</a></td>";
    table = table + "</tr>";
    table = table + "<tr><th>S</th><th>M</th><th>T</th><th>W</th><th>T</th><th>F</th><th>S</th></tr>";

    for(var week=0; week < 6; week++) {
      table = table + "<tr>";
      for(var dayOfWeek=0; dayOfWeek < 7; dayOfWeek++) {
        if(week == 0 && startDayOfWeek == dayOfWeek) {
          validDay = 1;
        } else if (validDay == 1 && dayOfMonth > daysInMonth) {
          validDay = 0;
        }

        if(validDay) {
          if (dayOfMonth == selectedDay && currentYear == selectedYear && currentMonth == selectedMonth) {
            css_class = 'current';
          } else if (dayOfWeek == 0 || dayOfWeek == 6) {
            css_class = 'weekend';
          } else {
            css_class = 'weekday';
          }

          table = table + "<td><a class='"+css_class+"' href=\"javascript:setCalendarControlDate("+currentYear+","+currentMonth+","+dayOfMonth+")\">"+dayOfMonth+"</a></td>";
          dayOfMonth++;
        } else {
          table = table + "<td class='empty'>&nbsp;</td>";
        }
      }
      table = table + "</tr>";
    }

    table = table + "<tr class='header'><th colspan='7' style='padding: 3px;'><a href='javascript:hideCalendarControl();'>Close</a> <a href='javascript:clearText();'>Clear</a></td></tr>";
    table = table + "</table>";

    return table;
  }

  this.show = show;
  function show(field) {
  
    // If the calendar is visible and associated with
    // this field do not do anything.
    if (dateField == field) {
      return;
    } else {
      dateField = field;
    }
    
	// getting value from the field
    if(dateField) {
      try {
        var dateString = new String(dateField.value);
        var dateParts = dateString.split("-");
        
        //selectedMonth = parseInt(dateParts[0],10);
        //selectedDay = parseInt(dateParts[1],10);
        //selectedYear = parseInt(dateParts[2],10);
        selectedDay = parseInt(dateParts[2],10);
        selectedMonth = parseInt(dateParts[1],10);
        selectedYear = parseInt(dateParts[0],10);
        
        
      } catch(e) {}
    }

    if (!(selectedYear && selectedMonth && selectedDay)) {
      selectedMonth = getCurrentMonth();
      selectedDay = getCurrentDay();
      selectedYear = getCurrentYear();
    }

    currentMonth = selectedMonth;
    currentDay = selectedDay;
    currentYear = selectedYear;

    if(document.getElementById){

      calendar = document.getElementById(calendarId);
      calendar.innerHTML = calendarDrawTable(currentYear, currentMonth);

      setElementProperty('display', 'block', 'CalendarControlIFrame');
      setProperty('display', 'block');

      var fieldPos = new positionInfo(dateField);
      var calendarPos = new positionInfo(calendarId);

      var x = fieldPos.getElementLeft();
      var y = fieldPos.getElementBottom();

      setProperty('left', x + "px");
      setProperty('top', y + "px");
      setElementProperty('left', x + "px", 'CalendarControlIFrame');
      setElementProperty('top', y + "px", 'CalendarControlIFrame');
      setElementProperty('width', calendarPos.getElementWidth() + "px", 'CalendarControlIFrame');
      setElementProperty('height', calendarPos.getElementHeight() + "px", 'CalendarControlIFrame');
    }
  }

  this.hide = hide;
  function hide() {
    if(dateField) {
      setProperty('display', 'none');
      setElementProperty('display', 'none', 'CalendarControlIFrame');
      dateField = null;
    }
  }
}

// --CALENDARCONTROLT--
// with timestamp added
function CalendarControlT() {

  var calendarId = 'CalendarControl';
  var currentYear = 0;
  var currentMonth = 0;
  var currentDay = 0;
  // added by G
  var currentHours=0;
  var currentMinutes=0;
  var currentSeconds=0;

  var selectedYear = 0;
  var selectedMonth = 0;
  var selectedDay = 0;
  // added by G
  var selectedHours=0;
  var selectedMinutes=0;
  var selectedSeconds=0;

  var months = ['January','February','March','April','May','June','July','August','September','October','November','December'];
  var dateField = null;

  function getProperty(p_property){
    var p_elm = calendarId;
    var elm = null;

    if(typeof(p_elm) == "object"){
      elm = p_elm;
    } else {
      elm = document.getElementById(p_elm);
    }
    if (elm != null){
      if(elm.style){
        elm = elm.style;
        if(elm[p_property]){
          return elm[p_property];
        } else {
          return null;
        }
      } else {
        return null;
      }
    }
  }

  function setElementProperty(p_property, p_value, p_elmId){
    var p_elm = p_elmId;
    var elm = null;

    if(typeof(p_elm) == "object"){
      elm = p_elm;
    } else {
      elm = document.getElementById(p_elm);
    }
    if((elm != null) && (elm.style != null)){
      elm = elm.style;
      elm[ p_property ] = p_value;
    }
  }

  function setProperty(p_property, p_value) {
    setElementProperty(p_property, p_value, calendarId);
  }

  function getDaysInMonth(year, month) {
    return [31,((!(year % 4 ) && ( (year % 100 ) || !( year % 400 ) ))?29:28),31,30,31,30,31,31,30,31,30,31][month-1];
  }

  function getDayOfWeek(year, month, day) {
    var date = new Date(year,month-1,day)
    return date.getDay();
  }

  this.setDate = setDate;
  function setDate(year, month, day, hour, minutes, seconds) {
    if (dateField) {
      if (month < 10) {month = "0" + month;}
      if (day < 10) {day = "0" + day;}
      // overwriting values
      var stringa = document.cal.time.value;
      hour = parseInt(stringa.substring(0,2));
      minutes = parseInt(stringa.substring(3,5));
      seconds = parseInt(stringa.substring(6,8));
      if (hour < 10) {hour = "0" + hour;}
      if (minutes < 10) {minutes = "0" + minutes;}
      if (seconds < 10) {seconds = "0" + seconds;}
      if (validate()){
         var dateString = year+"-"+month+"-"+day+" "+hour+":"+minutes+":"+seconds;
         dateField.value = dateString;
 	     hide();
      } else {
	      alert(" Formato non valido");
	      // focus to form
	      document.cal.time.focus();
      }
    }
    return;
  }
  
  this.clearText = clearText;
  function clearText() {
    if (dateField) {
      dateField.value = "";
      hide();
    }
    return;
  }

  this.changeMonth = changeMonth;
  function changeMonth(change) {
    currentMonth += change;
    currentDay = 0;
    if(currentMonth > 12) {
      currentMonth = 1;
      currentYear++;
    } else if(currentMonth < 1) {
      currentMonth = 12;
      currentYear--;
    }

    calendar = document.getElementById(calendarId);
    calendar.innerHTML = calendarDrawTable();
  }

  this.changeYear = changeYear;
  function changeYear(change) {
    currentYear += change;
    currentDay = 0;
    calendar = document.getElementById(calendarId);
    calendar.innerHTML = calendarDrawTable();
  }

  function getCurrentYear() {
    var year = new Date().getYear();
    if(year < 1900) year += 1900;
    return year;
  }

  function getCurrentMonth() {
    return new Date().getMonth() + 1;
  } 

  function getCurrentDay() {
    return new Date().getDate();
  }

  function getCurrentHours() {
    return new Date().getHours();
  }

  function getCurrentMinutes() {
    return new Date().getMinutes();
  } 

  function getCurrentSeconds() {
    return new Date().getSeconds();
  }

  function calendarDrawTable() {

    var dayOfMonth = 1;
    var validDay = 0;
    var startDayOfWeek = getDayOfWeek(currentYear, currentMonth, dayOfMonth);
    var daysInMonth = getDaysInMonth(currentYear, currentMonth);
    var css_class = null; //CSS class for each day

    var table = "<table cellspacing='0' cellpadding='0' border='0'>";
    table = table + "<tr class='header'>";
    table = table + "  <td colspan='2' class='previous'><a href='javascript:changeCalendarControlMonthT(-1);'>&lt;</a> <a href='javascript:changeCalendarControlYearT(-1);'>&laquo;</a></td>";
    table = table + "  <td colspan='3' class='title'>" + months[currentMonth-1] + "<br>" + currentYear + "</td>";
    table = table + "  <td colspan='2' class='next'><a href='javascript:changeCalendarControlYearT(1);'>&raquo;</a> <a href='javascript:changeCalendarControlMonthT(1);'>&gt;</a></td>";
    table = table + "</tr>";
    table = table + "<tr><th>S</th><th>M</th><th>T</th><th>W</th><th>T</th><th>F</th><th>S</th></tr>";

    for(var week=0; week < 6; week++) {
      table = table + "<tr>";
      for(var dayOfWeek=0; dayOfWeek < 7; dayOfWeek++) {
        if(week == 0 && startDayOfWeek == dayOfWeek) {
          validDay = 1;
        } else if (validDay == 1 && dayOfMonth > daysInMonth) {
          validDay = 0;
        }

        if(validDay) {
          if (dayOfMonth == selectedDay && currentYear == selectedYear && currentMonth == selectedMonth) {
            css_class = 'current';
          } else if (dayOfWeek == 0 || dayOfWeek == 6) {
            css_class = 'weekend';
          } else {
            css_class = 'weekday';
          }

          table = table + "<td><a class='"+css_class+"' href=\"javascript:setCalendarControlDateT("+currentYear+","+currentMonth+","+dayOfMonth+","+selectedHours+","+selectedMinutes+","+selectedSeconds+")\">"+dayOfMonth+"</a></td>";
          dayOfMonth++;
        } else {
          table = table + "<td class='empty'>&nbsp;</td>";
        }
      }
      table = table + "</tr>";
    }
   	// print calendar footer
   	var timeToString = currentHours+":"+currentMinutes+":"+currentSeconds;
	table = table + "<tr><td colspan='7' style='padding: 3px;'>";
	table = table + "<form name=\"cal\">Time: <input type=\"text\" name=\"time\" value=\""+timeToString+"\" size=\"8\" maxlength=\"8\" onblur=\"validate();\"></form>";
	table = table + "</td></tr>";
    table = table + "<tr class='header'><th colspan='7' style='padding: 3px;'><a href='javascript:hideCalendarControlT();'>Close</a> <a href='javascript:clearTextT();'>Clear</a></td></tr>";
    table = table + "</table>";
    return table;
  }

  // added by G
  this.validate = validate;
  function validate() {
    if(dateField) {
      var stringa = document.cal.time.value;
      selectedHours = stringa.substring(0,2);
      selectedMinutes = stringa.substring(3,5);
      selectedSeconds = stringa.substring(6,8);
      var h = parseInt(selectedHours);
      var m = parseInt(selectedMinutes);
      var s = parseInt(selectedSeconds);
      if (h>23 || m>59 || s>59){
      	return false;
      } else if (isNaN(h) || isNaN(m) || isNaN(s)){
      	return false;	
      }	else {
      	return true;
      }
    }
  }
  
  this.show = show;
  function show(field) {
    // If the calendar is visible and associated with
    // this field do not do anything.
    if (dateField == field) {
      return;
    } else {
      dateField = field;
    }
    	// getting value from the field
    if(dateField) {
      try {
        var dateString = new String(dateField.value);
        var dateParts = dateString.split("-");
        selectedDay = parseInt(dateParts[2],10);
        selectedMonth = parseInt(dateParts[1],10);
        selectedYear = parseInt(dateParts[0],10);
        var timeString = new String(dateField.value);
        var timeParts = timeString.split(" ");
        var time1 = timeParts[1];
        var timeParts2 = time1.split(":");
        selectedHours = parseInt(timeParts2[0],10);
        selectedMinutes = parseInt(timeParts2[1],10);
        selectedSeconds = parseInt(timeParts2[2],10);
        if (selectedHours < 10) {selectedHours = "0" + selectedHours;}
        if (selectedMinutes < 10) {selectedMinutes = "0" + selectedMinutes;}
        if (selectedSeconds < 10) {selectedSeconds = "0" + selectedSeconds;}
        //alert(selectedYear+" "+selectedMonth+" "+selectedDay+" "+selectedHours+" "+selectedMinutes+" "+selectedSeconds);
        
      } catch(e) {}
    }

    if (!(selectedYear && selectedMonth && selectedDay)) {
      selectedMonth = getCurrentMonth();
      selectedDay = getCurrentDay();
      selectedYear = getCurrentYear();
    }
    // addeb by G
    if (!(selectedHours && selectedMinutes && selectedSeconds)) {
      selectedHours = getCurrentHours();
      selectedMinutes = getCurrentMinutes();
      selectedSeconds = getCurrentSeconds();
    }

    currentMonth = selectedMonth;
    currentDay = selectedDay;
    currentYear = selectedYear;
	// added by G
    currentHours= selectedHours;
    currentMinutes = selectedMinutes;
    currentSeconds = selectedSeconds;

    if(document.getElementById){

      calendar = document.getElementById(calendarId);
      calendar.innerHTML = calendarDrawTable(currentYear, currentMonth);

      setElementProperty('display', 'block', 'CalendarControlIFrame');
      setProperty('display', 'block');

      var fieldPos = new positionInfo(dateField);
      var calendarPos = new positionInfo(calendarId);

      var x = fieldPos.getElementLeft();
      var y = fieldPos.getElementBottom();

      setProperty('left', x + "px");
      setProperty('top', y + "px");
      setElementProperty('left', x + "px", 'CalendarControlIFrame');
      setElementProperty('top', y + "px", 'CalendarControlIFrame');
      setElementProperty('width', calendarPos.getElementWidth() + "px", 'CalendarControlIFrame');
      setElementProperty('height', calendarPos.getElementHeight() + "px", 'CalendarControlIFrame');
    }
  }

  this.hide = hide;
  function hide() {
    if(dateField) {
      setProperty('display', 'none');
      setElementProperty('display', 'none', 'CalendarControlIFrame');
      dateField = null;
    }
  }
}


/*
	FUNZIONI VARIE
*/
var calendarControl = new CalendarControl();
var calendarControlT = new CalendarControlT();


// --CLEARTEXT--
function clearText() {
  calendarControl.clearText();
}

// --CLEARTEXTT--
function clearTextT() {
  calendarControlT.clearText();
}

// --SHOWCALENDARCONTROL--
function showCalendarControl(textField) {
  calendarControl.show(textField);
}
// --SHOWCALENDARCONTROLT--
function showCalendarControlT(textField) {
  calendarControlT.show(textField);
}

// --HIDECALENDARCONTROL--
function hideCalendarControl() {
  calendarControl.hide();
}
// --HIDECALENDARCONTROLT--
function hideCalendarControlT() {
  calendarControlT.hide();
}

// --SETCALENDAR--
function setCalendarControlDate(year, month, day) {
  calendarControl.setDate(year, month, day);
}
// --SETCALENDAR-T--
function setCalendarControlDateT(year, month, day, hours, minutes, seconds) {
  calendarControlT.setDate(year, month, day, hours, minutes, seconds);
}

// --CHANGECALENDARCONTROLYEAR--
function changeCalendarControlYear(change) {
  calendarControl.changeYear(change);
}
// --CHANGECALENDARCONTROLYEAR-T--
function changeCalendarControlYearT(change) {
  calendarControlT.changeYear(change);
}

// --CHANGECALENDARCONTROLMONTH--
function changeCalendarControlMonth(change) {
  calendarControl.changeMonth(change);
}
// --CHANGECALENDARCONTROLMONTH-T--
function changeCalendarControlMonthT(change) {
  calendarControlT.changeMonth(change);
}

// --CHANGECALENDARCONTROLMONTH-T--
function validate() {
  calendarControlT.validate();
}

// INIZIALIZZAZIONE
document.write("<iframe id='CalendarControlIFrame' src='javascript:false;' frameBorder='0' scrolling='no'></iframe>");
document.write("<div id='CalendarControl'></div>");
