package cmdbuild.action_forms;

import java.sql.*;
import java.util.*;

import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBclass;
import cmdbuild.collection.AttributeBean;
import cmdbuild.collection.ClassBean;
import cmdbuild.collection.InheritsBean;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;

public class AttributeForm extends ActionForm {

	static final long serialVersionUID = 1L;
	private String className;
	private String method;
	private String target;
	private String comment; // comment of this class
	private String mode;  // mode of this class
	private String superClassAttribute; // session object
	private String superClassFilter; // form object
	private int index;
	private int DBindex;
	private Vector namePosition;
	private Vector attributeBeanVector;
	private CMDBclass CMDB;


	public AttributeForm() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	/* (non-Javadoc)
	 * @see org.apache.struts.action.ActionForm#reset(org.apache.struts.action.ActionMapping, javax.servlet.http.HttpServletRequest)
	 */
	public void reset(ActionMapping mapping, HttpServletRequest request) {
		//method = "";
		
		if (request.getParameter("class") != null){
			className = request.getParameter("class");
		} else if (request.getSession().getAttribute("class") != null){
 			className = (String)request.getSession().getAttribute("class");
		}
        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
        CMDB = new CMDBclass(db);
        superClassAttribute = (String)request.getSession().getAttribute("superClassAttribute");
		if (superClassAttribute==null || superClassAttribute.equals("")){
			try { // get all attributes
				attributeBeanVector = CMDB.selectAllAttribute(className,"rw") ;		       
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		} else { // no inherited attributes
			InheritsBean inh = null;
			Vector supAttVector = new Vector();
			try {
				inh = CMDB.selectSuperClass(className);
				supAttVector = CMDB.selectAllAttribute(inh.getParent(),"rw");
			} catch (SQLException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
			try {
				attributeBeanVector = CMDB.selectAllAttribute(className,"rw") ;		       
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			Vector rv = new Vector();
			Enumeration en = supAttVector.elements();
			AttributeBean ab = null;
			Hashtable ht = new Hashtable(); // superclass attributes
			while (en.hasMoreElements()){
				ab = (AttributeBean)en.nextElement();
				ht.put(ab.getName(),ab);
			}
			en = attributeBeanVector.elements();
			while (en.hasMoreElements()){
				ab = (AttributeBean)en.nextElement();
				if (!ht.containsKey(ab.getName())){
					rv.add(ab);
				}
			}
			attributeBeanVector = rv;
		}
		ClassBean cb = CMDB.getBean();
		if (cb != null) {
			comment = cb.getComment();
			if (comment!=null && comment.length()>0){
				mode = comment.substring(6,comment.indexOf("|"));
			} else {
				mode = "read";
			}
			//System.out.println("mode is*"+mode+"*");
		}
	   request.setAttribute("attributeBeanVector", attributeBeanVector);
	}

	public Vector getAttributeBeanVector() {
		return attributeBeanVector;
	}
	public void setAttributeBeanVector(Vector attributeBeanVector) {
		this.attributeBeanVector = attributeBeanVector;
	}
	public String getClassName() {
		return className;
	}
	public void setClassName(String className) {
		this.className = className;
	}
	public CMDBclass getCMDB() {
		return CMDB;
	}
	public void setCMDB(CMDBclass cmdb) {
		CMDB = cmdb;
	}
	public String getComment() {
		return comment;
	}
	public void setComment(String comment) {
		this.comment = comment;
	}
	public int getDBindex() {
		return DBindex;
	}
	public void setDBindex(int bindex) {
		DBindex = bindex;
	}
	public int getIndex() {
		return index;
	}
	public void setIndex(int index) {
		this.index = index;
	}
	public String getMethod() {
		return method;
	}
	public void setMethod(String method) {
		this.method = method;
	}
	public String getMode() {
		return mode;
	}
	public void setMode(String mode) {
		this.mode = mode;
	}
	public Vector getNamePosition() {
		return namePosition;
	}
	public void setNamePosition(Vector namePosition) {
		this.namePosition = namePosition;
	}
	public String getSuperClassAttribute() {
		return superClassAttribute;
	}
	public void setSuperClassAttribute(String superClassAttribute) {
		this.superClassAttribute = superClassAttribute;
	}
	public String getSuperClassFilter() {
		return superClassFilter;
	}
	public void setSuperClassFilter(String superClassFilter) {
		this.superClassFilter = superClassFilter;
	}
	public String getTarget() {
		return target;
	}
	public void setTarget(String target) {
		this.target = target;
	}
	
} // end of class
