package cmdbuild.action_forms;
import java.sql.*;
import java.util.*;

import cmdbuild.presentation.HTMLclass;
import cmdbuild.collection.*;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBclass;
import cmdbuild.elements.CMDBlookup;
import cmdbuild.utils.MultiLanguage;
import cmdbuild.utils.SecurityDescriptor;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;

public class CardForm extends ActionForm {

	static final long serialVersionUID = 1L;
	private String name;
	private String classDescription="";
	private String method;
	private String mode;
	private String search; 
	private Vector columnVector;  // contains a list of parameters (attributes) to display
	private Vector rowIdVector; // contains all the row from the query
	private Vector attributeBeanVector;
	private Vector lookupVector; // contains objects lookup where name=type & description=<option></option>...
	private int currentPage=1;  // the first page corrisponds to vector[0]
	private int totalPages=0;
	private int rowId;  // contains the real id of the row
	private Collection classCollection; // only used in mode modify e create
	private CMDBclass CMDB;
	private HTMLclass presentation;

	public CardForm() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	/* (non-Javadoc)
	 * @see org.apache.struts.action.ActionForm#reset(org.apache.struts.action.ActionMapping, javax.servlet.http.HttpServletRequest)
	 */
	public void reset(ActionMapping mapping, HttpServletRequest request) {
		
		System.out.println("**CARDFORM RESET**");
        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
        CMDB = new CMDBclass(db);
	    if ( classCollection == null ) {
	    	classCollection = new ArrayList();
			try {
				classCollection = CMDB.selectAllClass();		       
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
	    }
		if (request.getParameter("class") != null){
			name = request.getParameter("class");
			request.getSession().setAttribute("class",name);
		} else if (request.getSession().getAttribute("class") != null){
 			name = (String)request.getSession().getAttribute("class");
		} else {
			name = "Asset";
		}
		ClassBean cb = null;
		// classid is passed from search.jsp if classname is Asset
		if (request.getParameter("classid") != null){
			int classid = Integer.parseInt(request.getParameter("classid"));
			if (classid!=0){
				try {
					cb = CMDB.selectClassById(classid);
					CMDB.setBean(cb);
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				name = cb.getName();
				request.getSession().setAttribute("class",name);
			}
		}
		if (request.getParameter("page") != null){
			currentPage = Integer.parseInt(request.getParameter("page"));
			request.getSession().setAttribute("page",""+currentPage);
		} else if (request.getSession().getAttribute("page") != null){
 			currentPage = Integer.parseInt((String) request.getSession().getAttribute("page"));
		}
		if (request.getParameter("mode") != null){
			mode = request.getParameter("mode");
			request.getSession().setAttribute("mode",mode);
		} else if (request.getSession().getAttribute("mode") != null){
			mode = (String) request.getSession().getAttribute("mode");
		} else {
			mode="";
		}
		System.out.println("mode="+mode+" classe="+name+" currentPage="+currentPage);
		// *** managing filter ***
		String baseQuery = "";
		// replacing select parameters with "Id"
		baseQuery = "SELECT \"Id\" FROM \""+name+"\" WHERE \"Status\"='A'";
        Hashtable filter = null;
        FilterBean fb = null;
        if (request.getSession().getAttribute("filter")!=null){
        	filter = (Hashtable)request.getSession().getAttribute("filter");
        	if (filter.containsKey(name)){
        		fb = (FilterBean)filter.get(name);
        		try {
            		rowIdVector = CMDB.selectCardsId(fb.getQuery());
        		} catch (SQLException e) {
        			e.printStackTrace();
        		}
        	} else {
        		try {
            		rowIdVector = CMDB.selectCardsId(baseQuery);
        		} catch (SQLException e) {
        			e.printStackTrace();
        		}
        	}
        } else {
    		try {
        		rowIdVector = CMDB.selectCardsId(baseQuery);
    		} catch (SQLException e) {
    			e.printStackTrace();
    		}
        }
		// objid is passed from search.jsp if classname is Asset
		if (request.getParameter("objid") != null){
			int objid = Integer.parseInt(request.getParameter("objid"));
			if (objid!=0){
				Enumeration eni = rowIdVector.elements();
				IdBean id = null;
				int pagina = 0;
				while (eni.hasMoreElements()){
					pagina++;
					id = (IdBean)eni.nextElement();
					if (id.getId()==objid){
						currentPage = pagina;
						break;
					}
				}
			}
			request.getSession().setAttribute("page",""+currentPage);
		}
		totalPages = rowIdVector.size();
		if (rowIdVector==null){System.out.println("rowIdVector  nullo!");}
		if (rowIdVector.size()>0){
			if(currentPage < 1){
				currentPage = 1;
			} else if (currentPage>totalPages){
				currentPage = 1;
				request.getSession().setAttribute("page",""+currentPage);
			}
			rowId = ((IdBean)rowIdVector.elementAt(currentPage-1)).getId(); // -1 beacause it's a vector
		} else { // There aren't cards
			currentPage = 0;
		}
		if (rowId==0){System.out.println("rowId  nullo!");}
		// get extra attributes for the class
		try {
			attributeBeanVector = CMDB.selectAllAttribute(name,"rw") ;		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		if (attributeBeanVector!=null && attributeBeanVector.size()>0){
			classDescription = ((AttributeBean)attributeBeanVector.elementAt(0)).getClassBean().getDescription(); 
		}
		Hashtable copypaste = (Hashtable)request.getSession().getAttribute("copypaste");
		Boolean usecopypaste = new Boolean(false);
		if (request.getSession().getAttribute("usecopypaste")!=null){
			usecopypaste = (Boolean)request.getSession().getAttribute("usecopypaste");
		}
		if (copypaste!=null && usecopypaste.booleanValue() && copypaste.containsKey(name)){
			columnVector = (Vector)copypaste.get(name);
			System.out.println("columnVector.size="+columnVector.size());
		} else {
			try {
				columnVector = CMDB.selectCard(name,rowId,attributeBeanVector);		       
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		if (columnVector==null){System.out.println("columnVector  nullo!");}
		
		// creating lookupVector if there are lookups
		Enumeration enu = columnVector.elements();
		lookupVector = new Vector();
		AssetBean ab = null;
		Vector options= null;
		if (enu==null){ System.out.println("enum  nullo"); }
		Hashtable hash = new Hashtable();
		CMDBlookup lookobj = new CMDBlookup(db);
		while (enu.hasMoreElements()){
			ab = (AssetBean)enu.nextElement();
			if (ab.getType().equals("lookup")){
				try {
					if (!hash.containsKey(ab.getLookup())){ // don't get duplicates
						System.out.println("Getting lookup for "+ab.getLookup());
						options = lookobj.selectLookupByType(ab.getLookup());
						hash.put(ab.getLookup(),ab.getLookup());
					}
					//System.out.println("options.size="+options.size());
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				if (options!=null){
					lookupVector.addAll(options);
				}
			}
		}
		System.out.println("lookup.size="+lookupVector.size());
		// cleaning page when page=0
		if (currentPage==0){
			Enumeration eni = columnVector.elements();
			AssetBean asb = null;
			while (eni.hasMoreElements()){
				asb = (AssetBean)eni.nextElement();
				asb.setValue(null);
			}
		}
		// getting general class info
        ClassBean bean = CMDB.getBean();
		// getting user from session
		SecurityDescriptor user = null;
		if (request.getSession().getAttribute("user")!=null){
			user = (SecurityDescriptor)request.getSession().getAttribute("user");
		}
		CMDB = CMDB.load(CMDB,CMDB.getBean().getManager());
		presentation = (HTMLclass)CMDB.getPresentation();
		MultiLanguage multilanguage = (MultiLanguage)request.getSession().getAttribute("multilanguage");
		presentation.setMultilanguage(multilanguage);
		presentation.setClassName(name);
		presentation.setCategory(bean.getCategory());
		presentation.setAssetVector(columnVector);
		if (usecopypaste.booleanValue()){ presentation.setToPaste(true); }
		presentation.setClassCollection(classCollection);
		presentation.setLookupVector(lookupVector);
		presentation.setClassDescription(classDescription);
		presentation.setUser(user);
		if (user.isAllowed(name,2)){
			presentation.getHeader().getCreate().setUrl("card.jsp?class="+name+"&mode=create");
			presentation.getHeader().getModify().setUrl("card.jsp?class="+name+"&mode=modify&page="+currentPage);
			presentation.getHeader().getDelete().setUrl("javascript:if (confirm('"+multilanguage.getMessage("CardForm.delete")+"')){cardForm.method.value='delete';cardForm.submit();}");
			if (mode.equals("show") && !CMDB.getBean().isSuperClass()){ // don't permit copy/paste if you are in a superclass
				presentation.getHeader().getCopy().setUrl("javascript:cardForm.method.value='copy';cardForm.submit();");
				presentation.getHeader().getCopy().setVisible(true);
				if (copypaste!=null && copypaste.containsKey(name)){ // if there are copies saved in the session
					presentation.getHeader().getPaste().setUrl("javascript:cardForm.method.value='paste';cardForm.submit();");
					presentation.getHeader().getPaste().setVisible(true);
				}
			}
		} else {
			presentation.getHeader().getCreate().setUrl("javascript:alert('"+multilanguage.getMessage("com.youhavenopermission")+"');");
			presentation.getHeader().getModify().setUrl("javascript:alert('"+multilanguage.getMessage("com.youhavenopermission")+"');");
			presentation.getHeader().getDelete().setUrl("javascript:alert('"+multilanguage.getMessage("com.youhavenopermission")+"');");
		}
		//presentation.getFilter().setUrl("card.jsp?class="+name+"&mode=filter&page="+currentPage);
		presentation.getHeader().getFilter().setVisible(false);
		//presentation.getNofilter().setUrl("javascript:cardForm.method.value='nofilter';cardForm.submit();");
		presentation.getHeader().getNofilter().setVisible(false);
		// settings arrows
		if (currentPage==0){
			presentation.getHeader().getFirst().setUrl("card.jsp?class="+name+"&page=0");
			presentation.getHeader().getPrev().setUrl("card.jsp?class="+name+"&page=0");
			presentation.getHeader().getNext().setUrl("card.jsp?class="+name+"&page=0");
		} else if (currentPage==1){
			presentation.getHeader().getFirst().setUrl("card.jsp?class="+name+"&page=1");
			presentation.getHeader().getPrev().setUrl("card.jsp?class="+name+"&page=1");
			presentation.getHeader().getNext().setUrl("card.jsp?class="+name+"&page=2");
		} else if(currentPage==totalPages) {
			presentation.getHeader().getFirst().setUrl("card.jsp?class="+name+"&page=1");
			presentation.getHeader().getPrev().setUrl("card.jsp?class="+name+"&page="+(totalPages-1));
			presentation.getHeader().getNext().setUrl("card.jsp?class="+name+"&page="+totalPages);
		} else {
			presentation.getHeader().getFirst().setUrl("card.jsp?class="+name+"&page=1");
			presentation.getHeader().getPrev().setUrl("card.jsp?class="+name+"&page="+(currentPage-1));
			presentation.getHeader().getNext().setUrl("card.jsp?class="+name+"&page="+(currentPage+1));
		}
		presentation.getHeader().getLast().setUrl("card.jsp?class="+name+"&page="+totalPages);
		// setting current page
		presentation.getHeader().getPage().setCurrent(currentPage);
		presentation.getHeader().getPage().setTotal(totalPages);
		presentation.getHeader().getLabel().setLabel("&nbsp;");
		// setting calendar reference
		presentation.setFormName("cardForm");
		presentation.getHeader().getCheckFilter().setVisible(false);
		String stat="";
		if (stat.equals("") || stat.equals("A")){
			presentation.setDeleted(false);
		} else {
			presentation.setDeleted(true);
		}
		// disable operations if className=Asset
		if (CMDB.getBean().isSuperClass()){
			presentation.getHeader().getCreate().setUrl("javascript:alert('"+multilanguage.getMessage("com.classreadonly")+"');");
			presentation.getHeader().getModify().setUrl("javascript:alert('"+multilanguage.getMessage("com.classreadonly")+"');");
			presentation.getHeader().getDelete().setUrl("javascript:alert('"+multilanguage.getMessage("com.classreadonly")+"');");
		}
	}

	public ActionErrors validate(ActionMapping arg0, HttpServletRequest arg1) {
		System.out.println("**VALIDATE**");
		mode = (String)arg1.getSession().getAttribute("mode");
		System.out.println("Mode is "+mode);
		ActionErrors errors = new ActionErrors();
		AssetBean ab = null;
		String tname = "";
		String tdescription = "";
		String target="";
		Enumeration en = columnVector.elements();
		while (!mode.equals("show") && en.hasMoreElements()){
			ab = (AssetBean)en.nextElement();
			if (ab.getMandatory().equals("Y")){
				tname = ab.getName();
				tdescription = ab.getDescription();
				target= arg1.getParameter(tname);
				//System.out.println("target is "+tname+"target value="+target);
				if (target == null || target.trim().equals("")){ // ,tname
					errors.add(tname, new ActionMessage("par.required",tdescription));
				} else { // if there is something
					if (ab.getType().equals("int4")){
						try {
							Integer.parseInt(target);
						} catch (NumberFormatException e){
							errors.add(tname, new ActionMessage("par.precision.to.integer",tdescription));
						}
					} // end int4
					if (ab.getType().equals("float8")){
						try {
							Double.parseDouble(target);
						} catch (NumberFormatException e){
							errors.add(tname, new ActionMessage("par.precision.to.double",tdescription));
						}
					} // end float8
					if (ab.getType().equals("numeric")){
						try {
							Double.parseDouble(target);
						} catch (NumberFormatException e){
							errors.add(tname, new ActionMessage("par.precision.to.double",tdescription));
						}
					} // end numeric
					if (ab.getType().equals("varchar")){
						if (target.length()>ab.getLength()){
							errors.add(tname, new ActionMessage("par.length.invalid",tdescription+"="+ab.getLength()));
						}
					} // end varchar
				} // end else	
			} else {  // not mandatory
				tname = ab.getName();
				tdescription = ab.getDescription();
				target= arg1.getParameter(tname);
				System.out.println("target value="+target);
				if (target != null && !target.trim().equals("")){ // if there is something
					if (ab.getType().equals("int4")){
						try {
							Integer.parseInt(target);
						} catch (NumberFormatException e){
							errors.add(tname, new ActionMessage("par.precision.to.integer",tdescription));
						}
					} // end numeric
					if (ab.getType().equals("float8")){
						try {
							Double.parseDouble(target);
						} catch (NumberFormatException e){
							errors.add(tname, new ActionMessage("par.precision.to.double",tdescription));
						}
					} // end numeric
					if (ab.getType().equals("numeric")){
						try {
							Double.parseDouble(target);
						} catch (NumberFormatException e){
							errors.add(tname, new ActionMessage("par.precision.to.double",tdescription));
						}
					} // end numeric
					if (ab.getType().equals("varchar")){
						if (target.length()>ab.getLength()){
							errors.add(tname, new ActionMessage("par.length.invalid",tdescription+"="+ab.getLength()));
						}
					} // end varchar
				} // end else	
			}
		}
		return errors;
	}
	
	public HTMLclass getPresentation() {
		return presentation;
	}
	public void setPresentation(HTMLclass presentation) {
		this.presentation = presentation;
	}
	public Vector getAttributeBeanVector() {
		return attributeBeanVector;
	}
	public void setAttributeBeanVector(Vector attributeBeanVector) {
		this.attributeBeanVector = attributeBeanVector;
	}
	public Collection getClassCollection() {
		return classCollection;
	}
	public void setClassCollection(Collection classCollection) {
		this.classCollection = classCollection;
	}
	public Vector getColumnVector() {
		return columnVector;
	}
	public void setColumnVector(Vector columnVector) {
		this.columnVector = columnVector;
	}
	public int getCurrentPage() {
		return currentPage;
	}
	public void setCurrentPage(int currentPage) {
		this.currentPage = currentPage;
	}
	public Vector getLookupVector() {
		return lookupVector;
	}
	public void setLookupVector(Vector lookupVector) {
		this.lookupVector = lookupVector;
	}
	public String getMethod() {
		return method;
	}
	public void setMethod(String method) {
		this.method = method;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public int getRowId() {
		return rowId;
	}
	public void setRowId(int rowId) {
		this.rowId = rowId;
	}
	public Vector getRowIdVector() {
		return rowIdVector;
	}
	public void setRowIdVector(Vector rowIdVector) {
		this.rowIdVector = rowIdVector;
	}
	public String getSearch() {
		return search;
	}
	public void setSearch(String search) {
		this.search = search;
	}
	public int getTotalPages() {
		return totalPages;
	}
	public void setTotalPages(int totalPages) {
		this.totalPages = totalPages;
	}
	public String getMode() {
		return mode;
	}
	public void setMode(String mode) {
		this.mode = mode;
	}
	public String getClassDescription() {
		return classDescription;
	}
	public void setClassDescription(String classDescription) {
		this.classDescription = classDescription;
	}
	

} // end class
