package cmdbuild.action_forms;
import java.sql.*;
import java.util.*;

import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBcategory;
import cmdbuild.elements.CMDBmacrocategory;
import cmdbuild.collection.CategoryBean;
import cmdbuild.collection.MacroCategoryBean;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;

public class CategoryForm extends ActionForm {
	
	static final long serialVersionUID = 1L;
	private String method;
	private String search;
	private String macroName;
	private String name; 
	private String target;
	private String index;
	private Vector categoryBeanVector;
	private Collection categoryType;
	private int macroCategoryId;

	public CategoryForm() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	/* (non-Javadoc)
	 * @see org.apache.struts.action.ActionForm#reset(org.apache.struts.action.ActionMapping, javax.servlet.http.HttpServletRequest)
	 */
	public void reset(ActionMapping mapping, HttpServletRequest request) {
		method = "";
		System.out.println("**CATEGORYFORM RESET**");
        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
        CMDBmacrocategory macroobj = new CMDBmacrocategory(db);
		if ( categoryType == null ) {
	    	categoryType = new ArrayList();
			try {
				categoryType = macroobj.selectAllMacroCategory();		       
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
	    }
		if (request.getSession().getAttribute("search")!=null){
			search = (String)request.getSession().getAttribute("search");
			request.getSession().setAttribute("search",null);
			System.out.println("from session search is="+search);
		}
		CMDBcategory catobj = new CMDBcategory(db); 
		if (search==null && categoryType!=null && !categoryType.isEmpty()){
			Iterator it = categoryType.iterator();
			MacroCategoryBean clb = null;
			while (it.hasNext()){ // getting first element
				clb = (MacroCategoryBean)it.next();
				break;
			}
			if (clb!=null){
				search = clb.getDescription();
			}
			try {
				categoryBeanVector = catobj.selectCategoryByIdMacro(clb.getId());
				Enumeration en = categoryBeanVector.elements();
				CategoryBean cb = null;
				while (en.hasMoreElements()){
					cb = (CategoryBean)en.nextElement();
					cb.setMacroCategory(clb.getDescription());
				}
				macroName = clb.getDescription();
			} catch (SQLException e) {
				// TODO Auto-generated cat
				e.printStackTrace();
			}
		} else if(categoryType!=null && categoryType.isEmpty()){
			
		} else {
			try {
				int idM = Integer.parseInt(search);
				categoryBeanVector = catobj.selectCategoryByIdMacro(idM);
				// getting macroCategory description
				String macro = "";
				Iterator ite = categoryType.iterator();
				MacroCategoryBean mcb = null;
				while (ite.hasNext()){
					mcb = (MacroCategoryBean)ite.next();
					if (mcb.getId()==idM){
						macro = mcb.getDescription();
					}
				}
				macroName = macro;
				Enumeration en = categoryBeanVector.elements();
				CategoryBean cb = null;
				while (en.hasMoreElements()){
					cb = (CategoryBean)en.nextElement();
					cb.setMacroCategory(macro);
				}
			} catch (SQLException e) {
				// TODO Auto-generated cat
				e.printStackTrace();
			}
		}
		if (!categoryType.isEmpty()){
			Iterator ite = categoryType.iterator();
			MacroCategoryBean be = null;
			while(ite.hasNext()){
				be = (MacroCategoryBean)ite.next();
				if (be.getDescription().equals(macroName)){
					macroCategoryId = be.getId();
				}
			}
		}
		
	} // end reset method

	public String getIndex() {
		return index;
	}
	public void setIndex(String index) {
		this.index = index;
	}
	public String getTarget() {
		return target;
	}
	public void setTarget(String target) {
		this.target = target;
	}
	public String getMethod() {
		return method;
	}
	public void setMethod(String method) {
		this.method = method;
	}
	public Vector getCategoryBeanVector() {
		return categoryBeanVector;
	}
	public void setCategoryBeanVector(Vector categoryBeanVector) {
		this.categoryBeanVector = categoryBeanVector;
	}
	public Collection getCategoryType() {
		return categoryType;
	}
	public void setCategoryType(Collection categoryType) {
		this.categoryType = categoryType;
	}
	public String getSearch() {
		return search;
	}
	public void setSearch(String search) {
		this.search = search;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public String getMacroName() {
		return macroName;
	}
	public void setMacroName(String macroName) {
		this.macroName = macroName;
	}
	public int getMacroCategoryId() {
		return macroCategoryId;
	}
	public void setMacroCategoryId(int macroCategoryId) {
		this.macroCategoryId = macroCategoryId;
	}
	
	

}  // end of class
