package cmdbuild.action_forms;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBgroup;
import cmdbuild.collection.SecurityBean;

import java.sql.SQLException;
import java.util.*;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;

public class CreateUserForm extends ActionForm {

	static final long serialVersionUID = 1L;
	private String method;
	private String userName;
	private String description;
	private String password;
	private String confirmPassword;
	private int[] groupId;
	private String status;
	private Collection groupsCollection;
	private Vector policyVector;
	private Vector usersVector;
	private Vector groupsVector;

	public CreateUserForm() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	/* (non-Javadoc)
	 * @see org.apache.struts.action.ActionForm#reset(org.apache.struts.action.ActionMapping, javax.servlet.http.HttpServletRequest)
	 */
	public void reset(ActionMapping mapping, HttpServletRequest request) {
		System.out.println("**CREATEUSER RESET**");
		method = "";
        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
        CMDBgroup grpobj = new CMDBgroup(db);
        try {
        	groupsVector = grpobj.selectAllGroup();
        } catch (SQLException e){
        	e.printStackTrace();
        }
        Hashtable gn = new Hashtable();
        Enumeration en = groupsVector.elements();
        SecurityBean sb = null;
        while (en.hasMoreElements()){
        	sb = (SecurityBean)en.nextElement();
        	if (!gn.containsKey(sb.getGroup())){
        		gn.put(sb.getGroup(),sb);
        	}
        }
        // creating a vector without duplicates of groups
        Vector groupNamesVector = new Vector();
        en = gn.elements();
        while (en.hasMoreElements()){
        	sb = (SecurityBean)en.nextElement();
        	groupNamesVector.add(sb);
        }
        sb = null;
        groupsCollection = new LinkedList();
        en = groupNamesVector.elements();
        while (en.hasMoreElements()){
        	sb = (SecurityBean)en.nextElement();
        	groupsCollection.add(sb);
        }
	}
	
	
	public ActionErrors validate(ActionMapping arg0, HttpServletRequest arg1) {
		ActionErrors errors = new ActionErrors();
		if (userName == null || userName.trim().equals("")){
			//errors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("form.field.required", "Nome tabella"));
			errors.add("userName", new ActionMessage("username.required"));
		}
		if (userName.indexOf(" ")!=-1){
			errors.add("userName", new ActionMessage("name.nospace"));
		}
		if (password == null || password.trim().equals("")){
			errors.add("password", new ActionMessage("password.required"));
		}
		if (confirmPassword == null || confirmPassword.trim().equals("")){
			errors.add("confirmPassword", new ActionMessage("password.required"));
		}
		if (password!=null && confirmPassword!=null && !password.equals(confirmPassword)){
			errors.add("confirmPassword", new ActionMessage("password.invalid"));
		}
		if (groupId==null || groupId.length==0){
			errors.add("role", new ActionMessage("role.required"));
		}
		return errors;
	}

	public String getConfirmPassword() {
		return confirmPassword;
	}
	public void setConfirmPassword(String confirmPassword) {
		this.confirmPassword = confirmPassword;
	}
	public String getDescription() {
		return description;
	}
	public void setDescription(String description) {
		this.description = description;
	}
	public Collection getGroupsCollection() {
		return groupsCollection;
	}
	public void setGroupsCollection(Collection groupsCollection) {
		this.groupsCollection = groupsCollection;
	}
	public Vector getGroupsVector() {
		return groupsVector;
	}
	public void setGroupsVector(Vector groupsVector) {
		this.groupsVector = groupsVector;
	}
	public String getMethod() {
		return method;
	}
	public void setMethod(String method) {
		this.method = method;
	}
	public String getPassword() {
		return password;
	}
	public void setPassword(String password) {
		this.password = password;
	}
	public Vector getPolicyVector() {
		return policyVector;
	}
	public void setPolicyVector(Vector policyVector) {
		this.policyVector = policyVector;
	}
	public String getStatus() {
		return status;
	}
	public void setStatus(String status) {
		this.status = status;
	}
	public String getUserName() {
		return userName;
	}
	public void setUserName(String userName) {
		this.userName = userName;
	}
	public Vector getUsersVector() {
		return usersVector;
	}
	public void setUsersVector(Vector usersVector) {
		this.usersVector = usersVector;
	}
	public int[] getGroupId() {
		return groupId;
	}
	public void setGroupId(int[] groupId) {
		this.groupId = groupId;
	}

} // end of class
