package cmdbuild.action_forms;

import java.sql.SQLException;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBgroup;
import cmdbuild.presentation.HTMLgroup;
import cmdbuild.utils.MultiLanguage;
import cmdbuild.collection.SecurityBean;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;

public class GroupForm extends ActionForm {
	
	static final long serialVersionUID = 1L;
	private String method;
	private	HTMLgroup presentation; 
	private Vector policyVector;
	private Vector groupsVector; // has only elements of this group
	private String group;
	private String search;
	private String target; // used to implement delection
	private boolean fullOperator = false;
	private String all; // this checkbox is used to set all classes to the same value

	public GroupForm() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	/* (non-Javadoc)
	 * @see org.apache.struts.action.ActionForm#reset(org.apache.struts.action.ActionMapping, javax.servlet.http.HttpServletRequest)
	 */
	public void reset(ActionMapping mapping, HttpServletRequest request) {
		method = "";
		fullOperator = false;
		System.out.println("**GROUPFORM RESET**");
        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
        groupsVector = new Vector();
        CMDBgroup GROUP = new CMDBgroup(db);
        try {
           	//groupsVector = db.selectAllGroup();
        	groupsVector = GROUP.selectAllGroup();
        } catch (SQLException e){
           	e.printStackTrace();
        }
        SecurityBean sb = null;
        if (request.getParameter("group")!=null){
        	group = request.getParameter("group");
        	request.getSession().setAttribute("group",group);
        } else if(request.getSession().getAttribute("group")!=null){
        	group = (String)request.getSession().getAttribute("group");
        } else {
        	group = ( (SecurityBean)groupsVector.elementAt(0) ).getGroup();
        }
        policyVector = new Vector(); // has only elements of this group
        Hashtable gn = new Hashtable();
        Enumeration en = groupsVector.elements();
        sb = null;
        while (en.hasMoreElements()){
        	sb = (SecurityBean)en.nextElement();
        	if (sb.getGroup().equals(group)){
        		policyVector.add(sb);
        	}
        	if (!gn.containsKey(sb.getGroup())){
        		gn.put(sb.getGroup(),sb);
        	}
        }
        // creating a vector without duplicates of groups
        Vector groupNamesVector = new Vector();
        en = gn.elements();
        while (en.hasMoreElements()){
        	sb = (SecurityBean)en.nextElement();
        	groupNamesVector.add(sb);
        }
        // getting all classes if is full operator
    	if (policyVector.size()>0){
    		en = policyVector.elements();
    		while(en.hasMoreElements()){
            	sb = (SecurityBean)en.nextElement();
                if (!sb.isAdministrator() && sb.getClassId()==0){
                	fullOperator = true;
                	break;
                }
    		}
    	}
        System.out.println("fullOperator="+fullOperator);
        presentation = new HTMLgroup(group,groupNamesVector,policyVector);
        MultiLanguage multilanguage = (MultiLanguage)request.getSession().getAttribute("multilanguage");
		presentation.setMultilanguage(multilanguage);
        presentation.setFullOperator(fullOperator);
        presentation.getHeader().getCreate().setUrl("");
        presentation.getHeader().getModify().setVisible(false);
        presentation.getHeader().getFilter().setVisible(false);
        presentation.getHeader().getNofilter().setVisible(false);
        presentation.getHeader().getCheckFilter().setVisible(false);
        presentation.getHeader().getDelete().setVisible(false);
        presentation.getHeader().getFirst().setVisible(false);
        presentation.getHeader().getPrev().setVisible(false);
        presentation.getHeader().getPage().setVisible(false);
        presentation.getHeader().getNext().setVisible(false);
        presentation.getHeader().getLast().setVisible(false);
        presentation.getHeader().getLabel().setVisible(false);
	} // end reset method

	public String getMethod() {
		return method;
	}
	public void setMethod(String method) {
		this.method = method;
	}
	public String getGroup() {
		return group;
	}
	public void setGroup(String group) {
		this.group = group;
	}
	public String getSearch() {
		return search;
	}
	public void setSearch(String search) {
		this.search = search;
	}
	public String getTarget() {
		return target;
	}
	public void setTarget(String target) {
		this.target = target;
	}
	public Vector getGroupsVector() {
		return groupsVector;
	}
	public void setGroupsVector(Vector groupsVector) {
		this.groupsVector = groupsVector;
	}
	public Vector getPolicyVector() {
		return policyVector;
	}
	public void setPolicyVector(Vector policyVector) {
		this.policyVector = policyVector;
	}
	public boolean isFullOperator() {
		return fullOperator;
	}
	public void setFullOperator(boolean fullOperator) {
		this.fullOperator = fullOperator;
	}
	public String getAll() {
		return all;
	}
	public void setAll(String all) {
		this.all = all;
	}
	public HTMLgroup getPresentation() {
		return presentation;
	}
	public void setPresentation(HTMLgroup presentation) {
		this.presentation = presentation;
	}

}  // end of class
