package cmdbuild.action_forms;

import java.sql.SQLException;
import java.util.Vector;

import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBuser;
import cmdbuild.collection.SecurityBean;
import cmdbuild.utils.SecurityDescriptor;
import cmdbuild.utils.SecurityEncrypter;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;

public class LoginForm extends ActionForm {

	static final long serialVersionUID = 1L;
	private String user;
	private String passwd;
	private String where;
	private String role;
	private String language; // the flags, hidden tag
	private boolean selectRole=false;
	private boolean validated=false;
	private String HTMLroles;
	
	public void reset(ActionMapping arg0, HttpServletRequest arg1) {
		user = "";
		passwd = "";
		// default Italian checked
		if (language==null || language.equals("")){
			language = "it";
		}
		System.out.println("**LOGINFORM RESET**");
	}

	public ActionErrors validate(ActionMapping arg0, HttpServletRequest arg1) {
		System.out.println("**LOGINFORM VALIDATE**");
		user = arg1.getParameter("user");
		passwd=arg1.getParameter("passwd");
		where= arg1.getParameter("where");
		SecurityBean sb = null;
		System.out.println("user="+user+" password="+passwd);
		ActionErrors errors = new ActionErrors();
		if (user == null || user.trim().equals("")){
			errors.add("user", new ActionMessage("username.required"));
		}
		if (passwd == null || passwd.trim().equals("")){
			errors.add("passwd", new ActionMessage("password.required"));
		}
        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
        CMDBuser USER = new CMDBuser(db);
		if ( ( user != null && !user.trim().equals("") && passwd != null && !passwd.trim().equals("") ) ){
	        Vector policyVector =null;
	        try {
				policyVector = USER.selectPolicyByUsername(user);	
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			if (policyVector!=null && policyVector.size()>0){ // real authentication
				sb = (SecurityBean)policyVector.elementAt(0);
				//SecurityEncrypter se = new SecurityEncrypter("27071978");
				SecurityEncrypter se = new SecurityEncrypter();
				String encpass = se.encrypt(passwd);
				if (sb.getPassword().equals(encpass) && !sb.isAdministrator() && where.equals("Gestione") && sb.getStatus().equals("A")){
					SecurityDescriptor userSD = new SecurityDescriptor(sb.getUsername(),sb.getDescription(),sb.isAdministrator());
					HttpSession session = arg1.getSession(true);
					session.setAttribute("logged","true");
					arg1.getSession().setAttribute("user",userSD);
				} else if (sb.getPassword().equals(encpass) && sb.isAdministrator() && sb.getStatus().equals("A")){
					SecurityDescriptor userSD = new SecurityDescriptor(sb.getUsername(),sb.getDescription(),sb.isAdministrator());
					HttpSession session = arg1.getSession(true);
					session.setAttribute("logged","true");
					arg1.getSession().setAttribute("user",userSD);
				} else {
					errors.add("login", new ActionMessage("login.notallowed"));
					System.out.println("lOGIN FALLITO");
				}
			} else {
				errors.add("login", new ActionMessage("login.notallowed"));
				System.out.println("lOGIN FALLITO");
			}
		}
		if (errors.isEmpty()){
			//System.out.println("no err selectRole="+selectRole);
			if (selectRole==true){
				validated = true;
				System.out.println("validated");
			} else {
				selectRole = true;
				System.out.println("selected role");
			}
		} else {
			validated = false;
			selectRole = false;
		}
		return errors;
	}

	public String getPasswd() {
		return passwd;
	}
	public void setPasswd(String passwd) {
		this.passwd = passwd;
	}
	public String getUser() {
		return user;
	}
	public void setUser(String user) {
		this.user = user;
	}
	public String getWhere() {
		return where;
	}
	public void setWhere(String where) {
		this.where = where;
	}
	public boolean isSelectRole() {
		return selectRole;
	}
	public void setSelectRole(boolean selectRole) {
		this.selectRole = selectRole;
	}
	public boolean isValidated() {
		return validated;
	}
	public void setValidated(boolean validated) {
		this.validated = validated;
	}
	public String getHTMLroles() {
		return HTMLroles;
	}
	public void setHTMLroles(String lroles) {
		HTMLroles = lroles;
	}
	public String getRole() {
		return role;
	}
	public void setRole(String role) {
		this.role = role;
	}
	public String getLanguage() {
		return language;
	}
	public void setLanguage(String language) {
		this.language = language;
	}
	
} // end of class
