package cmdbuild.action_forms;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBgroup;
import cmdbuild.elements.CMDBuser;
import cmdbuild.collection.SecurityBean;

import java.sql.SQLException;
import java.util.*;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;

public class ModifyUserForm extends ActionForm {

	static final long serialVersionUID = 1L;
	private String method;
	private int id; // user id
	private String userName;
	private String description;
	private String password;
	private String confirmPassword;
	private int[] groupId;
	private String status;
	private Vector policyVector;
	private String HTMLOptionGroups;
	private Vector realPolicyVector;

	public ModifyUserForm() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	/* (non-Javadoc)
	 * @see org.apache.struts.action.ActionForm#reset(org.apache.struts.action.ActionMapping, javax.servlet.http.HttpServletRequest)
	 */
	public void reset(ActionMapping mapping, HttpServletRequest request) {
		System.out.println("**MODIFYUSER RESET**");
		method = "";
		if (request.getParameter("user")!=null){
			userName = request.getParameter("user");
		} else {
			System.out.println("user is null!");
		}
		SecurityBean sb = null;
		Vector groupsVector = new Vector();
		DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		CMDBuser USER = new CMDBuser(db);
		CMDBgroup GROUP = new CMDBgroup(db);
        try {
        	policyVector = USER.selectAllPolicy();
        } catch (SQLException e){
        	e.printStackTrace();
        }
        try {
        	groupsVector = GROUP.selectAllGroup();
        } catch (SQLException e){
        	e.printStackTrace();
        }
        Hashtable gn = new Hashtable();
        Enumeration en = groupsVector.elements();
        sb = null;
        while (en.hasMoreElements()){
        	sb = (SecurityBean)en.nextElement();
        	if (!gn.containsKey(sb.getGroup())){
        		gn.put(sb.getGroup(),sb);
        	}
        }
        // creating a vector without duplicates of groups
        Vector groupNamesVector = new Vector();
        en = gn.elements();
        while (en.hasMoreElements()){
        	sb = (SecurityBean)en.nextElement();
        	groupNamesVector.add(sb);
        }
        System.out.println("user="+userName);
		en = policyVector.elements();
		realPolicyVector = new Vector();
		Hashtable selectedGroups = new Hashtable();
		while (en.hasMoreElements()){
			sb = (SecurityBean)en.nextElement();
			if (sb.getUsername().equals(userName)){
				realPolicyVector.add(sb);
				if (!selectedGroups.containsKey(sb.getGroupId()+"")){
					selectedGroups.put(sb.getGroupId()+"",sb);
				}
			}
		}
		if (sb==null){
			System.out.println("sb is null!");
		}
		if (sb!=null){
			id = sb.getId();
			description = sb.getDescription();
			status = sb.getStatus();
			//System.out.println("sb status="+status);
		}
        en = groupNamesVector.elements();
        HTMLOptionGroups = "";
        while (en.hasMoreElements()){
        	sb = (SecurityBean)en.nextElement();
        	if (!selectedGroups.containsKey(sb.getGroupId()+"")){
        		HTMLOptionGroups += "<option value=\""+sb.getGroupId()+"\">"+sb.getGroup()+"</option>";	
        	} else {
        		HTMLOptionGroups += "<option value=\""+sb.getGroupId()+"\" selected>"+sb.getGroup()+"</option>";
        	}
        }
	}
	
	public ActionErrors validate(ActionMapping arg0, HttpServletRequest arg1) {
		ActionErrors errors = new ActionErrors();
		if (userName == null || userName.trim().equals("")){
			//errors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("form.field.required", "Nome tabella"));
			errors.add("userName", new ActionMessage("username.required"));
		}
		if (userName.indexOf(" ")!=-1){
			errors.add("userName", new ActionMessage("name.nospace"));
		}
		if (password == null || password.trim().equals("")){
			errors.add("password", new ActionMessage("password.required"));
		}
		if (confirmPassword == null || confirmPassword.trim().equals("")){
			errors.add("confirmPassword", new ActionMessage("password.required"));
		}
		if (password!=null && confirmPassword!=null && !password.equals(confirmPassword)){
			errors.add("confirmPassword", new ActionMessage("password.invalid"));
		}
		if (groupId==null || groupId.length==0){
			errors.add("role", new ActionMessage("role.required"));
		}
		return errors;
	}

	public String getConfirmPassword() {
		return confirmPassword;
	}
	public void setConfirmPassword(String confirmPassword) {
		this.confirmPassword = confirmPassword;
	}
	public String getDescription() {
		return description;
	}
	public void setDescription(String description) {
		this.description = description;
	}
	public String getMethod() {
		return method;
	}
	public void setMethod(String method) {
		this.method = method;
	}
	public String getPassword() {
		return password;
	}
	public void setPassword(String password) {
		this.password = password;
	}
	public Vector getPolicyVector() {
		return policyVector;
	}
	public void setPolicyVector(Vector policyVector) {
		this.policyVector = policyVector;
	}
	public String getStatus() {
		return status;
	}
	public void setStatus(String status) {
		this.status = status;
	}
	public String getUserName() {
		return userName;
	}
	public void setUserName(String userName) {
		this.userName = userName;
	}
	public String getHTMLOptionGroups() {
		return HTMLOptionGroups;
	}
	public void setHTMLOptionGroups(String optionGroups) {
		HTMLOptionGroups = optionGroups;
	}
	public int getId() {
		return id;
	}
	public void setId(int id) {
		this.id = id;
	}
	public int[] getGroupId() {
		return groupId;
	}
	public void setGroupId(int[] groupId) {
		this.groupId = groupId;
	}
	public Vector getRealPolicyVector() {
		return realPolicyVector;
	}
	public void setRealPolicyVector(Vector realPolicyVector) {
		this.realPolicyVector = realPolicyVector;
	}
	

} // end of class
