package cmdbuild.action_forms;
import java.sql.*;
import java.util.*;

import cmdbuild.presentation.HTMLclass;
import cmdbuild.collection.*;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBclass;
import cmdbuild.elements.CMDBlookup;
import cmdbuild.utils.MultiLanguage;
import cmdbuild.utils.SecurityDescriptor;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;

public class PopupInfoCardForm extends ActionForm {

	static final long serialVersionUID = 1L;
	private String className;
	private String classDescription="";
	private String method;
	private int classId;
	private int objId;
	private HTMLclass presentation; // object that generates HTML code
	private Vector columnVector;  // contains a list of parameters (attributes) to display
	private Vector attributeBeanVector;
	private Vector lookupVector; // contains objects lookup where name=type & description=<option></option>...


	public PopupInfoCardForm() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	public void reset(ActionMapping mapping, HttpServletRequest request) {
		lookupVector=new Vector();
		
		System.out.println("**POPUPINFOCARD RESET**");
		if (request.getParameter("class") != null){
			className = request.getParameter("class");
		} else if (request.getSession().getAttribute("class") != null){
 			className = (String)request.getSession().getAttribute("class");
		}
		if (request.getParameter("classid") != null){
			classId = Integer.parseInt(request.getParameter("classid"));
		} 
		if (request.getParameter("objid") != null){
			objId = Integer.parseInt(request.getParameter("objid"));
		}
        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
        CMDBclass CMDB = new CMDBclass(db);
		if (CMDB.getBean()==null){
			try {
				CMDB.setBean(CMDB.selectClassByName(className));
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		// get extra attributes for the class
		try {
			attributeBeanVector = CMDB.selectAllAttribute(className,"rw") ;		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		if (attributeBeanVector!=null && attributeBeanVector.size()>0){
			classDescription= ((AttributeBean)attributeBeanVector.elementAt(0)).getClassBean().getDescription(); 
		}
		try {
			columnVector = CMDB.selectCard(className,objId,attributeBeanVector);		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		if (columnVector==null){System.out.println("columnVector  nullo!");}
		// creating lookupVector if there are lookups
		Enumeration enu = columnVector.elements();
		AssetBean ab = null;
		Vector options= new Vector();
		if (enu==null){ System.out.println("enum  nullo"); }
		CMDBlookup LOOKUP = new CMDBlookup(db);
		while (enu.hasMoreElements()){
			ab = (AssetBean)enu.nextElement();
			if (ab.getType().equals("lookup")){
				try {
					options = LOOKUP.selectLookupByType(ab.getLookup()) ;		       
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				Enumeration en = options.elements();
				LookupBean lb = null;
				while ( en.hasMoreElements()){
					lb = (LookupBean)en.nextElement();
					lookupVector.add(lb);
					//System.out.println("added to lookupVector:"+lb.getLType());
				}
			}
		}
		// getting general class info
        ClassBean bean = new ClassBean();
		try {
			bean= CMDB.selectClassByName(className);	
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		// getting user from session
		SecurityDescriptor user = null;
		String us = null;
		if (request.getSession().getAttribute("user")!=null){
			user = (SecurityDescriptor)request.getSession().getAttribute("user");
			us = user.getUserName();
		}
		// Creating card Asset
		//asset = new Asset(className,columnVector,lookupVector);
		CMDB = CMDB.load(CMDB,CMDB.getBean().getManager());
		MultiLanguage multilanguage = (MultiLanguage)request.getSession().getAttribute("multilanguage");
		presentation.setMultilanguage(multilanguage);
		presentation = (HTMLclass)CMDB.getPresentation();
		presentation.setClassName(className);
		presentation.setAssetVector(columnVector);
		presentation.setLookupVector(lookupVector);
		presentation.setCategory(bean.getCategory());
		presentation.setClassDescription(classDescription);
		presentation.setUser(user);
		presentation.getHeader().setVisible(false);
		String stat="";
		try {
			stat = CMDB.getCardStatus(className,objId);		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		if (stat==null){
			try {
				CMDB.setCardStatus(className,objId,"A",us);	
				stat = "A";
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		if (stat.equals("") || stat.equals("A")){
			presentation.setDeleted(false);
		} else {
			presentation.setDeleted(true);
		}

	}

	public ActionErrors validate(ActionMapping arg0, HttpServletRequest arg1) {
		System.out.println("**VALIDATE**");
		ActionErrors errors = new ActionErrors();
		return errors;
	}
	public Vector getAttributeBeanVector() {
		return attributeBeanVector;
	}
	public void setAttributeBeanVector(Vector attributeBeanVector) {
		this.attributeBeanVector = attributeBeanVector;
	}
	public int getClassId() {
		return classId;
	}
	public void setClassId(int classId) {
		this.classId = classId;
	}
	public String getClassName() {
		return className;
	}
	public void setClassName(String className) {
		this.className = className;
	}
	public Vector getColumnVector() {
		return columnVector;
	}
	public void setColumnVector(Vector columnVector) {
		this.columnVector = columnVector;
	}
	public Vector getLookupVector() {
		return lookupVector;
	}
	public void setLookupVector(Vector lookupVector) {
		this.lookupVector = lookupVector;
	}
	public String getMethod() {
		return method;
	}
	public void setMethod(String method) {
		this.method = method;
	}
	public int getObjId() {
		return objId;
	}
	public void setObjId(int objId) {
		this.objId = objId;
	}
	public String getClassDescription() {
		return classDescription;
	}
	public void setClassDescription(String classDescription) {
		this.classDescription = classDescription;
	}
	public HTMLclass getPresentation() {
		return presentation;
	}
	public void setPresentation(HTMLclass presentation) {
		this.presentation = presentation;
	}
	
} // end class
