package cmdbuild.action_forms;
import java.sql.*;
import java.util.*;

import cmdbuild.presentation.HTMLclass;
import cmdbuild.collection.*;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBclass;
import cmdbuild.elements.CMDBlookup;
import cmdbuild.elements.CMDBmap;
import cmdbuild.utils.MultiLanguage;
import cmdbuild.utils.SecurityDescriptor;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;

public class RelationForm extends ActionForm {

	static final long serialVersionUID = 1L;
	private String className;
	private String classDescription="";
	private int classId;
	private String method;
	private String mode;
	private String targetClass; // used to implement "go to page" 
	private String targetClassId; // used for implement delete
	private String targetObjId; // used to implement "go to page"
	private String targetDomain; // used for implement delete
	private String targetDomainId; // used for implement delete
	private String direct; // used for implement delete
	private String search; 
	private HTMLclass presentation; // object that generates HTML code
	private Vector columnVector;  // contains a list of parameters (attributes) to display
	private Vector rowIdVector; // contains all the row from the query
	private Vector attributeBeanVector;
	private Vector relationVector;
	private Vector lookupVector; // contains objects lookup where name=type & description=<option></option>...
	private int currentPage=1;  // the first page corrisponds to vector[0]
	private int totalPages=0;
	private int rowId;  // contains the real id of the row
	private LabelsBean labelsBean;

	public RelationForm() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	/* (non-Javadoc)
	 * @see org.apache.struts.action.ActionForm#reset(org.apache.struts.action.ActionMapping, javax.servlet.http.HttpServletRequest)
	 */
	public void reset(ActionMapping mapping, HttpServletRequest request) {
		//name = "";
		presentation = new HTMLclass();
		lookupVector=new Vector();
		relationVector = new Vector();

		// setting in the session relationForm
		request.getSession().setAttribute("relationForm",this);
		
		System.out.println("**RELATION FORM RESET**");
        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
        CMDBclass CMDB = new CMDBclass(db);
		if (request.getParameter("class") != null){
			className = request.getParameter("class");
			request.getSession().setAttribute("class",className);
		} else if (request.getSession().getAttribute("class") != null){
			className = (String)request.getSession().getAttribute("class");
		} else {
			className = "Asset";
		}
		// classid is passed from search.jsp if classname is Asset
		if (request.getParameter("classid") != null){
			classId = Integer.parseInt(request.getParameter("classid"));
			try {
				CMDB.selectClassById(classId);
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			if (CMDB.getBean()!=null){
				className = CMDB.getBean().getName();
				request.getSession().setAttribute("class",className);
			}
		}
		if (CMDB.getBean()==null){
			try {
				CMDB.setBean(CMDB.selectClassByName(className));
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		if (request.getParameter("page") != null){
			currentPage = Integer.parseInt(request.getParameter("page"));
			request.getSession().setAttribute("page",""+currentPage);
		} else if (request.getSession().getAttribute("page") != null){
 			currentPage = Integer.parseInt((String) request.getSession().getAttribute("page"));
		}

		System.out.println("name="+className+" currentPage="+currentPage);
		// getting subpage
		int subpage=0;
		if (request.getParameter("subpage")!=null){
			subpage = Integer.parseInt(request.getParameter("subpage"));
		} 
		// *** managing filter ***
		String baseQuery = "";
		// replacing select parameters with "Id"
		baseQuery = "SELECT \"Id\" FROM \""+className+"\" WHERE \"Status\"='A'";
        Hashtable filter = null;
        FilterBean fb = null;
        if (request.getSession().getAttribute("filter")!=null){
        	filter = (Hashtable)request.getSession().getAttribute("filter");
        	if (filter.containsKey(className)){
        		fb = (FilterBean)filter.get(className);
        		try {
            		rowIdVector = CMDB.selectCardsId(fb.getQuery());
        		} catch (SQLException e) {
        			e.printStackTrace();
        		}
        	} else {
        		try {
            		rowIdVector = CMDB.selectCardsId(baseQuery);
        		} catch (SQLException e) {
        			e.printStackTrace();
        		}
        	}
        } else {
    		try {
        		rowIdVector = CMDB.selectCardsId(baseQuery);
    		} catch (SQLException e) {
    			e.printStackTrace();
    		}
        }
		// objid is passed from search.jsp if classname is Asset
		if (request.getParameter("objid") != null){
			int objid = Integer.parseInt(request.getParameter("objid"));
			if (objid!=0){
				Enumeration eni = rowIdVector.elements();
				IdBean id = null;
				int pagina = 0;
				while (eni.hasMoreElements()){
					pagina++;
					id = (IdBean)eni.nextElement();
					if (id.getId()==objid){
						currentPage = pagina;
						break;
					}
				}
			}
			request.getSession().setAttribute("page",""+currentPage);
		}
		// used for popup windows
		if (className!=null && currentPage!=0){
			request.getSession().setAttribute("classToForward",className);
			request.getSession().setAttribute("pageToForward",(currentPage+""));
			System.out.println("**PAGE TO FORWARD**"+className+"-"+currentPage);
		}
		totalPages = rowIdVector.size();
		if (rowIdVector==null){System.out.println("rowIdVector  nullo!");}
		if (rowIdVector.size()>0){
			if(currentPage < 1){
				System.out.println("<1");
				currentPage = 1;
			} else if (currentPage>totalPages){
				currentPage = 1;
				System.out.println("1");
			}
			rowId = ((IdBean)rowIdVector.elementAt(currentPage-1)).getId(); // -1 beacause it's a vector
			classId = ((IdBean)rowIdVector.elementAt(currentPage-1)).getClassId();
		} else { // There aren't cards
			currentPage = 0;
			System.out.println("0");
		}
		System.out.println("classid="+classId+" rowId="+rowId);
		if (rowId==0){System.out.println("rowId  nullo!");}
		// get extra attributes for the class
		try {
			attributeBeanVector = CMDB.selectAllAttribute(className,"rw") ;		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		if (attributeBeanVector!=null && attributeBeanVector.size()>0){
			classDescription = ((AttributeBean)attributeBeanVector.elementAt(0)).getClassBean().getDescription(); 
		}
		try {
			columnVector = CMDB.selectCard(className,rowId,attributeBeanVector);		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		if (columnVector==null){System.out.println("columnVector  nullo!");}
		
		// creating lookupVector if there are lookups
		Enumeration enu = columnVector.elements();
		lookupVector = new Vector();
		AssetBean ab = null;
		Vector options= null;
		if (enu==null){ System.out.println("enum  nullo"); }
		Hashtable hash = new Hashtable();
		CMDBlookup LOOKUP = new CMDBlookup(db);
		while (enu.hasMoreElements()){
			ab = (AssetBean)enu.nextElement();
			if (ab.getType().equals("lookup")){
				try {
					if (!hash.containsKey(ab.getLookup())){ // don't get duplicates
						System.out.println("Getting lookup for "+ab.getLookup());
						options = LOOKUP.selectLookupByType(ab.getLookup());
						hash.put(ab.getLookup(),ab.getLookup());
					}
					//System.out.println("options.size="+options.size());
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				if (options!=null){
					lookupVector.addAll(options);
				}
			}
		}
		System.out.println("lookup.size="+lookupVector.size());
		if (classId==0){
			// getting class ID
			try {
				classId = CMDB.selectClassByName(className).getId();
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		int offset;
		if (subpage==0 || subpage==1){
			//subpage=1;
			offset=0;
		} else {
			offset=(subpage-1)*presentation.getResultsForPage();
		}
		int totalSubPages = 0;
		CMDBmap MAP = new CMDBmap(db);
		try {
			relationVector = MAP.selectRelations(classId,rowId,presentation.getResultsForPage(),offset);
			// 
			String quer = "SELECT * FROM relationlist WHERE idclass1="+classId+" AND idobj1="+rowId+" AND status='A'";
			totalSubPages = CMDB.countCards(quer);
			if (totalSubPages==1){ // patch
				subpage=1;
			}
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		System.out.println(" relationVector.size "+relationVector.size());
		
		RelationBean rb = null;
		Hashtable cardin = new Hashtable(); 
		Enumeration enume = relationVector.elements();
		int count;
		while (enume.hasMoreElements()){
			rb = (RelationBean)enume.nextElement();
			 // count relations for every domain and put in the session for createRelation
			 if (!cardin.containsKey(rb.getDomainRealName())){
				 cardin.put(rb.getDomainRealName(),1+"");
			 } else {
				 count = 1 + Integer.parseInt( (String)cardin.get(rb.getDomainRealName()) );
				 cardin.put(rb.getDomainRealName(),count+"");
			 }
			 //System.out.println("RelationForm classdescription is "+rb.getClassDescription());
		}
		request.getSession().setAttribute("cardinHashTable",cardin);
		try {
			labelsBean = CMDB.selectCardLabels(className,rowId);		       
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		// getting user from session
		SecurityDescriptor user = null;
		if (request.getSession().getAttribute("user")!=null){
			user = (SecurityDescriptor)request.getSession().getAttribute("user");
		}
		// Creating card Relation
		//relation = new presentation(columnVector,lookupVector,presentationVector,classId,rowId);
		CMDB = CMDB.load(CMDB,CMDB.getBean().getManager());
		MultiLanguage multilanguage = (MultiLanguage)request.getSession().getAttribute("multilanguage");
		presentation.setMultilanguage(multilanguage);
		presentation.setAssetVector(columnVector);
		presentation.setLookupVector(lookupVector);
		presentation.setRelationVector(relationVector);
		presentation.setClass1id(classId);
		presentation.setObj1id(rowId);
		presentation.setUser(user);
		if (user.isAllowed(className,3)){
			presentation.getHeader().getCreate().setUrl("createrelation.jsp?class="+className+"&page="+currentPage+"&class1id="+classId+"&obj1id="+rowId);
			presentation.getHeader().getCreate().setWhere("popup");
		} else {
			presentation.getHeader().getCreate().setUrl("javascript:alert('Non hai i permessi necessari');");
			presentation.getHeader().getCreate().setWhere("inner");
		}
		presentation.getHeader().getModify().setVisible(false);
		presentation.getHeader().getFilter().setVisible(false);
		presentation.getHeader().getDelete().setVisible(false);
		presentation.getHeader().getNofilter().setVisible(false);
		// settings arrows
		if (currentPage==0){
			presentation.getHeader().getFirst().setUrl("relation.jsp?class="+className+"&page=0");
			presentation.getHeader().getPrev().setUrl("relation.jsp?class="+className+"&page=0");
			presentation.getHeader().getNext().setUrl("relation.jsp?class="+className+"&page=0");
		} else if (currentPage==1){
			presentation.getHeader().getFirst().setUrl("relation.jsp?class="+className+"&page=1");
			presentation.getHeader().getPrev().setUrl("relation.jsp?class="+className+"&page=1");
			presentation.getHeader().getNext().setUrl("relation.jsp?class="+className+"&page=2");
		} else if(currentPage==totalPages) {
			presentation.getHeader().getFirst().setUrl("relation.jsp?class="+className+"&page=1");
			presentation.getHeader().getPrev().setUrl("relation.jsp?class="+className+"&page="+(totalPages-1));
			presentation.getHeader().getNext().setUrl("relation.jsp?class="+className+"&page="+totalPages);
		} else {
			presentation.getHeader().getFirst().setUrl("relation.jsp?class="+className+"&page=1");
			presentation.getHeader().getPrev().setUrl("relation.jsp?class="+className+"&page="+(currentPage-1));
			presentation.getHeader().getNext().setUrl("relation.jsp?class="+className+"&page="+(currentPage+1));
		}
		presentation.getHeader().getLast().setUrl("relation.jsp?class="+className+"&page="+totalPages);
		// setting current page
		presentation.getHeader().getPage().setCurrent(currentPage);
		presentation.getHeader().getPage().setTotal(totalPages);
		if (currentPage!=0){
			// setting label
			presentation.getHeader().getLabel().setLabel(classDescription+" - "+labelsBean.getCode()+"<BR>"+labelsBean.getDescription());
		} else {
			presentation.getHeader().getLabel().setLabel(" - ");
		}
		// this is passed to popup modifypresentation
		presentation.setClassName(className);
		// managing shows of 30 rows for page
		presentation.setSubpage(subpage);
		presentation.setTotalPages(totalSubPages);
		presentation.getHeader().getCheckFilter().setVisible(false);
		/*
		// disable operations if className=Asset
		if (className.equals("Asset")){
			presentation.getCreate().setUrl("javascript:alert('Classe non modificabile');");
			presentation.getCreate().setWhere("inner");
		}
		*/

	}

	public Vector getAttributeBeanVector() {
		return attributeBeanVector;
	}
	public void setAttributeBeanVector(Vector attributeBeanVector) {
		this.attributeBeanVector = attributeBeanVector;
	}
	public Vector getColumnVector() {
		return columnVector;
	}
	public void setColumnVector(Vector columnVector) {
		this.columnVector = columnVector;
	}
	public int getCurrentPage() {
		return currentPage;
	}
	public void setCurrentPage(int currentPage) {
		this.currentPage = currentPage;
	}
	public Vector getLookupVector() {
		return lookupVector;
	}
	public void setLookupVector(Vector lookupVector) {
		this.lookupVector = lookupVector;
	}
	public String getMethod() {
		return method;
	}
	public void setMethod(String method) {
		this.method = method;
	}
	public String getClassName() {
		return className;
	}
	public void setClassName(String className) {
		this.className = className;
	}

	public int getRowId() {
		return rowId;
	}
	public void setRowId(int rowId) {
		this.rowId = rowId;
	}
	public Vector getRowIdVector() {
		return rowIdVector;
	}
	public void setRowIdVector(Vector rowIdVector) {
		this.rowIdVector = rowIdVector;
	}
	public String getSearch() {
		return search;
	}
	public void setSearch(String search) {
		this.search = search;
	}
	public int getTotalPages() {
		return totalPages;
	}
	public void setTotalPages(int totalPages) {
		this.totalPages = totalPages;
	}
	public String getMode() {
		return mode;
	}
	public void setMode(String mode) {
		this.mode = mode;
	}
	public String getTargetClass() {
		return targetClass;
	}
	public void setTargetClass(String targetClass) {
		this.targetClass = targetClass;
	}
	public String getTargetObjId() {
		return targetObjId;
	}
	public void setTargetObjId(String targetObjId) {
		this.targetObjId = targetObjId;
	}
	public String getTargetClassId() {
		return targetClassId;
	}
	public void setTargetClassId(String targetClassId) {
		this.targetClassId = targetClassId;
	}
	public int getClassId() {
		return classId;
	}
	public void setClassId(int classId) {
		this.classId = classId;
	}
	public String getDirect() {
		return direct;
	}
	public void setDirect(String direct) {
		this.direct = direct;
	}
	public String getTargetDomain() {
		return targetDomain;
	}
	public void setTargetDomain(String targetDomain) {
		this.targetDomain = targetDomain;
	}
	public String getTargetDomainId() {
		return targetDomainId;
	}
	public void setTargetDomainId(String targetDomainId) {
		this.targetDomainId = targetDomainId;
	}
	public LabelsBean getLabelsBean() {
		return labelsBean;
	}
	public void setLabelsBean(LabelsBean labelsBean) {
		this.labelsBean = labelsBean;
	}
	public String getClassDescription() {
		return classDescription;
	}
	public void setClassDescription(String classDescription) {
		this.classDescription = classDescription;
	}
	public HTMLclass getPresentation() {
		return presentation;
	}
	public void setPresentation(HTMLclass presentation) {
		this.presentation = presentation;
	}
	public Vector getRelationVector() {
		return relationVector;
	}
	public void setRelationVector(Vector relationVector) {
		this.relationVector = relationVector;
	}

} // end class
