package cmdbuild.actions;

import java.sql.SQLException;
import java.util.*;

import cmdbuild.action_forms.CardForm;
import cmdbuild.collection.AssetBean;
import cmdbuild.collection.ErrorBean;
import cmdbuild.collection.IdBean;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBclass;
import cmdbuild.utils.CleaningVector;
import cmdbuild.utils.SecurityDescriptor;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.actions.DispatchAction;

public class CardAction extends DispatchAction {

	/* (non-Javadoc)
	 * @see org.apache.struts.action.Action#execute(org.apache.struts.action.ActionMapping, org.apache.struts.action.ActionForm, javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	public ActionForward create(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		System.out.println("**CREATE**");
		DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		ErrorBean err = null;
		Vector columnVector = null;
		AssetBean bean = null;
		String name = ((CardForm)form).getName();
		columnVector = ((CardForm)form).getColumnVector();
		Enumeration en = columnVector.elements();
		String value;
		// getting values from request
		while (en.hasMoreElements()){
			bean = (AssetBean)en.nextElement();
			value = request.getParameter(bean.getName());
			if (bean.getType().equals("bool")){
				if (value.equals("S")){
					value="true";
				} else {
					value = "false";
				}
			}
			bean.setValue(value);
		}
		// adding idclass idcategory
		AssetBean as = (AssetBean)columnVector.elementAt(0);
		Vector colVect = new Vector();
		AssetBean ass1 = new AssetBean();
		ass1.setName("IdClass");
		ass1.setType("int4");
		ass1.setValue(as.getClassBean().getId()+"");
		AssetBean ass2 = new AssetBean();
		ass2.setName("IdCategory");
		ass2.setType("int4");
		ass2.setValue(as.getClassBean().getIdCategory()+"");
		colVect.add(ass1);
		colVect.add(ass2);
		colVect.addAll(columnVector);
		columnVector=colVect;
		// setting attributes to be cleaned if are ''
		CleaningVector clean = new CleaningVector(columnVector);
		columnVector = clean.getCleanedVector();
		// cleaning the null parameters
		AssetBean ass = null;
		for (int ii=columnVector.size()-1;ii>-1;ii--){
			ass = (AssetBean)columnVector.elementAt(ii);
			if (ass.isToDelete()){
				//System.out.println("Removing "+ass.getAName());
				columnVector.remove(ii);
			} else {
				//System.out.println("Not removing "+ass.getAName());
			}
		}
		// adding Status
		AssetBean stat = new AssetBean();
		stat.setName("Status");
		stat.setSQLType("varchar");
		stat.setType("varchar");
		stat.setValue("A");
		columnVector.add(stat);
		boolean ok = false;
		// getting user from session
		SecurityDescriptor user = null;
		String us = null;
		if (request.getSession().getAttribute("user")!=null){
			user = (SecurityDescriptor)request.getSession().getAttribute("user");
			us = user.getUserName();
		}
		CMDBclass CMDB = new CMDBclass(db);
		try {
			ok = CMDB.createCard(name,columnVector,us);			
		} catch( SQLException ex ) { // patch postgres bug
			//ok = db.createCard(name,newColumnVector);
			err = new ErrorBean("card.jsp",ex);
		}
		if (ok){
			System.out.println("Scheda creata");
			//request.getSession().setAttribute("mode","show");
			//request.getSession().setAttribute("filterBean",null);
			int Id = 0;
			IdBean ib = null;
			Vector rowIdVector = null;
    		try {
    			String query = "SELECT \"Id\" FROM \""+name+"\" WHERE \"Status\"='A' ";
    			rowIdVector = CMDB.selectCardsId(query);
    			Id = CMDB.getCardId(name,columnVector);
    		} catch (SQLException e) {
    			// TODO Auto-generated catch block
    			err = new ErrorBean("card.jsp",e);
    		}
    		// getting the page
    		int page = 1;
    		Enumeration enim = rowIdVector.elements();
    		while (enim.hasMoreElements()){
    			ib = (IdBean)enim.nextElement();
    			if (Id==ib.getId()){
    				break;
    			}
    			page++;
    		}
    		int totpages = ((CardForm)form).getTotalPages();
    		if (totpages!=0 && page>totpages+1){
    			page=totpages+1;
    		}
    		((CardForm)form).setMode("show");
    		// sending to page
    		request.getSession().setAttribute("page",(page+""));
    		((CardForm)form).setCurrentPage(page);
    		//request.setAttribute("page",(page+""));
    		request.getSession().setAttribute("filterBean",null);
    		System.out.println("CA-create page is "+page);
		}
		if (err==null){
			((CardForm)form).reset(mapping,request);
			request.getSession().setAttribute("mode","show");
			return mapping.findForward("create");
		} else {
			System.out.println("Scheda non creata");
			request.getSession().setAttribute("error",err);
			return mapping.findForward("error");
		}
	}
	
	public ActionForward modify(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		System.out.println("**MODIFY**");
		DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		ErrorBean err = null;
		CMDBclass CMDB = new CMDBclass(db);
		Vector columnVector = null;
		AssetBean bean = null;
		String name = ((CardForm)form).getName();
		columnVector = ((CardForm)form).getColumnVector();
		int id = ((CardForm)form).getRowId();
		System.out.println("rowId prima della modifica="+id);
		Enumeration en = columnVector.elements();
		int i=0;
		while (en.hasMoreElements()){
			bean = (AssetBean)en.nextElement();
			if (bean.getName().equals("Notes") || bean.getName().equals("IdCategory")){
				columnVector.remove(i);
				System.out.println("Removing "+bean.getName());
			}
			i++;
		}
		String value="";
		en = columnVector.elements();
		// setting the couple (name,value);
		while (en.hasMoreElements()){
			bean = (AssetBean)en.nextElement();
			// recovers values from the query string
			value= (String)request.getParameter(bean.getName());
			if (value==null || value.equals("") || value.equals("null")){
				if (bean.getMandatory().equals("Y")){
					bean.setToDelete(true);
				} else {
					bean.setValue(null);
				}
			} else {
				if (bean.getType().equals("bool")){
					if (value.equals("S")){
						value="true";
					} else {
						value = "false";
					}
				}
				bean.setValue(value);
			}
			System.out.println("nome="+bean.getName()+" valore="+value);
		}
		// cleaning the null parameters
		AssetBean ass = null;
		for (int ii=columnVector.size()-1;ii>-1;ii--){
			ass = (AssetBean)columnVector.elementAt(ii);
			if (ass.isToDelete()){
				//System.out.println("Removing "+ass.getAName());
				columnVector.remove(ii);
			} else {
				//System.out.println("Not removing "+ass.getAName());
			}
		}
		// getting user from session
		SecurityDescriptor user = null;
		String us = null;
		if (request.getSession().getAttribute("user")!=null){
			user = (SecurityDescriptor)request.getSession().getAttribute("user");
			us = user.getUserName();
		}
		boolean ok = false;
		try {
			ok = CMDB.modifyCard(name,id,columnVector,us);
		} catch (SQLException e){
			err = new ErrorBean("card.jsp",e);
		}
		((CardForm)form).setMode("show");
		if (ok && err==null){
			System.out.println("Scheda modificata");
			request.getSession().setAttribute("mode","show");
			((CardForm)form).reset(mapping,request);
			return mapping.findForward("modify");
		} else {
			request.getSession().setAttribute("error",err);
			System.out.println("Scheda non modificata");
			return mapping.findForward("error");
		}
	}

	public ActionForward delete(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		System.out.println("**DELETE**");
		DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		ErrorBean err = null;
		CMDBclass CMDB = new CMDBclass(db);
		String className = ((CardForm)form).getName();
		int objId = ((CardForm)form).getRowId();
		String status = "";
		try {
			status = CMDB.getCardStatus(className,objId);
		} catch (SQLException e){
			err = new ErrorBean("card.jsp",e);
		}
		// changing status
		if (status.equals("") || status.equals("A")){
			status = "N";
		} else { // N
			status = "A";
		}
		System.out.println("Setting status "+status+" for "+className+" id="+objId);
		// getting user from session
		SecurityDescriptor user = null;
		String us = null;
		if (request.getSession().getAttribute("user")!=null){
			user = (SecurityDescriptor)request.getSession().getAttribute("user");
			us = user.getUserName();
		}
		try {
			CMDB.setCardStatus(className,objId,status,us);	
		} catch (SQLException e){
			err = new ErrorBean("card.jsp",e);
		}
		//db.deleteCard(className,objId);
		if (err==null){
			((CardForm)form).reset(mapping,request);
			request.getSession().setAttribute("mode","show");
			return mapping.findForward("delete");
		} else {
			request.getSession().setAttribute("error",err);
			return mapping.findForward("error");
		}
	}

	public ActionForward filter(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		System.out.println("**FILTER**");
		Enumeration n = request.getParameterNames();
		String className = request.getParameter("name");
		String target = "";
		String value = "";
		String filter = "";
		String f_value="";
		Vector rowIdVector = new Vector();
		Vector filterVector = new Vector(); // contains WHERE conditions of the query
		while (n.hasMoreElements()){
			target = (String)n.nextElement();
			value = request.getParameter(target);
			//System.out.println("CardAction target="+target+" value="+value);
			if (value!=null && !value.trim().equals("") && !value.equals("&nbsp;")){
				filter = "f_"+target;
				f_value = request.getParameter(filter);
				//System.out.println("CardAction filter="+filter+" f_value="+f_value);
				if (f_value!=null && f_value.equals("uguale")){
					filter = "\""+target+"\"='"+value+"'";
					filterVector.add(filter);
				} else if (f_value!=null && f_value.equals("=")){
						filter = "\""+target+"\"='"+value+"'";
						filterVector.add(filter);
				} else if (f_value!=null && f_value.equals("<")){
					filter = "\""+target+"\"<'"+value+"'";
					filterVector.add(filter);
				} else if (f_value!=null && f_value.equals(">")){
					filter = "\""+target+"\">'"+value+"'";
					filterVector.add(filter);
				} else if (f_value!=null && f_value.equals("contiene")){
					filter = "\""+target+"\" LIKE '%"+value+"%'";
					filterVector.add(filter);
				} else if (f_value!=null && f_value.equals("inizia con")){
					filter = "\""+target+"\" LIKE '"+value+"%'";
					filterVector.add(filter);
				}
			}
		}
		DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		ErrorBean err = null;
		CMDBclass CMDB = new CMDBclass(db);
		try {
			rowIdVector = CMDB.selectFilteredCardsId(className,filterVector);
		} catch (SQLException e){
			err = new ErrorBean("card.jsp",e);
		}
		if (err==null){
			//System.out.println("In filter_ rowIdVector.size="+rowIdVector.size());
			request.getSession().setAttribute("mode","show");
			// saved in the session, allow showing of subset of cards
			Hashtable filterBean = null;
			if (request.getSession().getAttribute("filterBean")!=null){
				filterBean = (Hashtable)request.getSession().getAttribute("filterBean");
				filterBean.put(className,rowIdVector);
			} else {
				filterBean = new Hashtable();
				filterBean.put(className,rowIdVector);
			}
			request.getSession().setAttribute("filterBean",filterBean); 
			((CardForm)form).setRowIdVector(rowIdVector);
			// going to page 1
			request.getSession().setAttribute("page",1+"");
			((CardForm)form).reset(mapping,request);
			return mapping.findForward("filter");
		} else {
			request.getSession().setAttribute("error",err);
			return mapping.findForward("error");
		}
		
	}
	
	public ActionForward nofilter(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		System.out.println("**CLEARFILTER**");
		String className = request.getParameter("name");
		// saved in the session, allow showing of subset of cards
		Hashtable filterBean = null;
		if (request.getSession().getAttribute("filterBean")!=null){
			filterBean = (Hashtable)request.getSession().getAttribute("filterBean");
			if (filterBean.containsKey(className)){
				System.out.println("Removing "+className);
				filterBean.remove(className);
			}
		}
		// only for searchForm page
		Hashtable reportBean = null;
		if (request.getSession().getAttribute("reportBean")!=null){
			reportBean = (Hashtable)request.getSession().getAttribute("reportBean");
			if (reportBean.containsKey(className)){
				System.out.println("Removing "+className);
				reportBean.remove(className);
			}
		}
		DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		ErrorBean err = null;
		CMDBclass CMDB = new CMDBclass(db);
		Vector rowIdVector = null;
		try {
			rowIdVector = CMDB.selectCardsId(className);	
		} catch (SQLException e){
			err = new ErrorBean("card.jsp",e);
		}
		if (err==null){
			((CardForm)form).setRowIdVector(rowIdVector);
			request.getSession().setAttribute("filterBean",filterBean); 
			((CardForm)form).reset(mapping,request);
			return mapping.findForward("filter");
		} else {
			request.getSession().setAttribute("error",err); 
			return mapping.findForward("error");
		}
	}
	
	public ActionForward search(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		System.out.println("**SEARCH**");
		String search = ((CardForm)form).getSearch();
		System.out.println("Search action="+search);
		((CardForm)form).setName(search);
		request.getSession().setAttribute("class",search);
		// calling reset method
		((CardForm)form).reset(mapping,request);
		return mapping.findForward("search");
	   }

	public ActionForward copy(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		System.out.println("**COPY**");
		Vector vett = ((CardForm)form).getColumnVector();
		String name = ((CardForm)form).getName();
		Hashtable copypaste = null;
		System.out.println("vett.size="+vett.size());
		if (request.getSession().getAttribute("copypaste")==null){
			copypaste = new Hashtable();
			copypaste.put(name,vett);
			request.getSession().setAttribute("copypaste",copypaste);
		} else {
			copypaste = (Hashtable)request.getSession().getAttribute("copypaste");
			copypaste.put(name,vett); // eventually overwrite old value
			request.getSession().setAttribute("copypaste",copypaste);
		}
		// calling reset method
		((CardForm)form).reset(mapping,request);
		return mapping.findForward("copy");
	   }
	
	public ActionForward paste(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		System.out.println("**PASTE**");
		request.getSession().setAttribute("mode","create");
		request.getSession().setAttribute("usecopypaste",new Boolean(true));
		request.setAttribute("mode","create");
		((CardForm)form).reset(mapping,request);
		return mapping.findForward("paste");
	   }
	
} // end of class
