package cmdbuild.actions;

import java.sql.SQLException;

import cmdbuild.action_forms.CreateRelationForm;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBmap;
import cmdbuild.collection.DomainBean;
import cmdbuild.utils.SecurityDescriptor;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.actions.DispatchAction;

public class CreateRelationAction extends DispatchAction {

	/* (non-Javadoc)
	 * @see org.apache.struts.action.Action#execute(org.apache.struts.action.ActionMapping, org.apache.struts.action.ActionForm, javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	
	public ActionForward modify(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		System.out.println("**MODIFY**");
		CreateRelationForm myform = (CreateRelationForm)form;
		int class1id = myform.getClass1id();
		int obj1id =   myform.getObj1id();
		int class2id = myform.getClass2id();
		int obj2id = myform.getObj2id();
		DomainBean domain = null;
		DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		String domainANDdesc = myform.getDomain();
		String domN = domainANDdesc.substring(0,domainANDdesc.indexOf("-"));
		String domD = domainANDdesc.substring(domainANDdesc.indexOf("-")+1,domainANDdesc.length());
		CMDBmap MAP = new CMDBmap(db);
		try {
			 domain = MAP.selectDomainByName(domN);
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		System.out.println("domain.getDirectDescription()="+domain.getDirectDescription()+" domain.getInverseDescription()="+domain.getInverseDescription());
		// getting user from session
		SecurityDescriptor user = null;
		String us = null;
		if (request.getSession().getAttribute("user")!=null){
			user = (SecurityDescriptor)request.getSession().getAttribute("user");
			us = user.getUserName();
		}
		try {
			if (domD.equals(domain.getDirectDescription())){ 
				MAP.createRelation(domain.getName(),domain.getId(),class1id,obj1id,class2id,obj2id,us);
			} else { // .equals(domain.getInverseDescription())
				MAP.createRelation(domain.getName(),domain.getId(),class2id,obj2id,class1id,obj1id,us);
			}
		} catch (SQLException e) { // patch postgres bug
		}	
		String close="ok";
		request.getSession().setAttribute("close",close);
		return mapping.findForward("modify");
		//	return mapping.findForward("error");
	}

	public ActionForward search(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		System.out.println("**SEARCH**");
		String domain = request.getParameter("search");
		((CreateRelationForm)form).setDomainToSearch(domain);
		//((CreateRelationForm)form).reset(mapping,request);
		return mapping.findForward("search");
	}
	
} // end of class
