package cmdbuild.actions;

import java.sql.SQLException;
import java.util.*;

import cmdbuild.action_forms.LookupForm;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBlookup;
import cmdbuild.collection.LookupBean;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.actions.DispatchAction;

public class LookupAction extends DispatchAction {

	/* (non-Javadoc)
	 * @see org.apache.struts.action.Action#execute(org.apache.struts.action.ActionMapping, org.apache.struts.action.ActionForm, javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	public ActionForward up(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		String target = ((LookupForm)form).getTarget(); // hidden tag
		String search = ((LookupForm)form).getSearch();
		Vector lookupBeanVector = null;
        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
        CMDBlookup LOOKUP = new CMDBlookup(db);
		try {
			lookupBeanVector = LOOKUP.selectLookupByType(search);
		} catch (SQLException e) {
			// TODO Auto-generated cat
			e.printStackTrace();
		}
        System.out.println("trying up");
		// find target position in vector
		boolean first = false; 
		LookupBean el=null;
		el = (LookupBean)lookupBeanVector.firstElement();
		if (el.getDescription().equals(target)){
			first = true;
		}
		if (first){ // do nothing
			System.out.println("first");
			return mapping.findForward("up");
		} else { // push down
			int vpos=0;
			LookupBean cb = null;
			for (int i=0;i<=lookupBeanVector.size();i++){
				cb = (LookupBean)lookupBeanVector.elementAt(i);
				if (cb.getDescription().equals(target)) { // if found in list
					vpos = i; 
					break;
				}
			}
			LookupBean t1 = (LookupBean)lookupBeanVector.elementAt(vpos); // clicked target
			LookupBean t2 = (LookupBean)lookupBeanVector.elementAt(vpos-1);
			try {
				int s1 = t1.getSequence();
				int s2 = t2.getSequence();
				t1.setSequence(s2);  // t1 now has t2.sequence
				t2.setSequence(s1);  // t2 now has t1.sequence
				System.out.println("writing t1");
				LOOKUP.modifyLookup(t1.getId(),t1);
				System.out.println("writing t2");
				LOOKUP.modifyLookup(t2.getId(),t2);
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			//request.getSession().setAttribute("class",tabname);
			// to refresh page
			((LookupForm)form).reset(mapping,request);
			return mapping.findForward("up");
		}
	}

	public ActionForward down(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		String target = ((LookupForm)form).getTarget(); // hidden tag
		String search = ((LookupForm)form).getSearch();
		Vector lookupBeanVector = null;
        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
        CMDBlookup lookobj = new CMDBlookup(db);
		try {
			lookupBeanVector = lookobj.selectLookupByType(search);
		} catch (SQLException e) {
			// TODO Auto-generated cat
			e.printStackTrace();
		}
        System.out.println("trying down");
		// find target position in vector
		boolean last = false; 
		LookupBean el=null;
		el = (LookupBean)lookupBeanVector.lastElement();
		if (el.getDescription().equals(target)){
			last = true;
		}
		if (last){ // do nothing
			System.out.println("last");
			return mapping.findForward("down");
		} else { // push down
			int vpos=0;
			LookupBean cb = null;
			for (int i=0;i<=lookupBeanVector.size();i++){
				cb = (LookupBean)lookupBeanVector.elementAt(i);
				if (cb.getDescription().equals(target)) { // if found in list
					vpos = i; 
					break;
				}
			}
			LookupBean t1 = (LookupBean)lookupBeanVector.elementAt(vpos); // clicked target
			LookupBean t2 = (LookupBean)lookupBeanVector.elementAt(vpos+1);
			try {
				int s1 = t1.getSequence();
				int s2 = t2.getSequence();
				t1.setSequence(s2);  // t1 now has t2.sequence
				t2.setSequence(s1);  // t2 now has t1.sequence
				System.out.println("writing t1");
				lookobj.modifyLookup(t1.getId(),t1);
				System.out.println("writing t2");
				lookobj.modifyLookup(t2.getId(),t2);
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			//request.getSession().setAttribute("class",tabname);
			// to refresh page
			((LookupForm)form).reset(mapping,request);
			return mapping.findForward("down");
		}
	}

	public ActionForward del(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		System.out.println("**LOOKUPACTION-del**");
		String tabname = ((LookupForm)form).getName();
		//String target = ((LookupForm)form).getTarget(); // hidden tag
		String search = ((LookupForm)form).getSearch();
		Vector lookupBeanVector = null;
        DBService db = (DBService)servlet.getServletContext().getAttribute("db");
        CMDBlookup LOOKUP = new CMDBlookup(db);
		try {
			lookupBeanVector = LOOKUP.selectLookupByType(search);
		} catch (SQLException e) {
			// TODO Auto-generated cat
			e.printStackTrace();
		}
		String ind =  ((LookupForm)form).getIndex(); // hidden tag
		int index = Integer.parseInt(ind);
		LookupBean cb = null;
		// getting the correct bean
		Enumeration en = lookupBeanVector.elements();
		while (en.hasMoreElements()){
			cb = (LookupBean)en.nextElement();
			if (cb.getSequence()==index){
				break;
			}
		}
		System.out.println("trying deletion");
		try {
			// changing status
			if (cb.getStatus().equals("A")){ // active
				cb.setStatus("N");
			} else { // no active
				cb.setStatus("A");
			}
			LOOKUP.modifyLookup(cb.getId(),cb);
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		request.getSession().setAttribute("class",tabname);
		request.setAttribute("class",tabname);
		// to refresh page
		((LookupForm)form).reset(mapping,request);
		return mapping.findForward("del");
	}
	
	public ActionForward search(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		String search = ((LookupForm)form).getSearch();
		System.out.println("Stringa search ="+search);
		((LookupForm)form).reset(mapping, request);
		return mapping.findForward("search");
	}

} // end of class
