package cmdbuild.actions;


import java.sql.SQLException;
import java.util.Enumeration;
import java.util.Vector;

import cmdbuild.action_forms.ModifyAttributeForm;
import cmdbuild.db.DBService;
import cmdbuild.elements.CMDBclass;
import cmdbuild.elements.CMDBlookup;
import cmdbuild.collection.AttributeBean;
import cmdbuild.collection.ErrorBean;
import cmdbuild.collection.LookupBean;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.actions.DispatchAction;

public class ModifyAttributeAction extends DispatchAction {

	public ActionForward modify(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		AttributeBean bean = new AttributeBean();
		String tabname = ((ModifyAttributeForm)form).getClassName();
		String mode = ((ModifyAttributeForm)form).getAMode();
		boolean ok = false;
		ErrorBean err = null;
		DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		CMDBclass CMDB = new CMDBclass(db);
		if (mode!=null && mode.equals("write")){ // write mode
			String newname = ((ModifyAttributeForm)form).getAName();
			String oldname = ((ModifyAttributeForm)form).getName(); // oldname
			bean.setName(oldname);
			bean.setIndex(((ModifyAttributeForm)form).getAIndex());
			String description = ((ModifyAttributeForm)form).getADescription();
			bean.setDescription(description);
			String type = ((ModifyAttributeForm)form).getAType();
			String SQLtype="";
			String extraInput="";
			String lookup="";
			if (type.equals("numeric")){
				extraInput = ((ModifyAttributeForm)form).getExtraInput();
				extraInput = extraInput.replace('.',','); 
				SQLtype = type+"("+extraInput+")";
				bean.setSQLType(SQLtype);
			} else if (type.equals("varchar")) {
				extraInput = ((ModifyAttributeForm)form).getExtraInput();
				SQLtype = type+"("+extraInput+")";
				bean.setSQLType(SQLtype);
			} else if (type.equals("lookup")){
				lookup = ((ModifyAttributeForm)form).getALookup();
				bean.setSQLType("int4"); // defined in database table LookUp
				bean.setLookup(lookup);
			} else { // for the othes aType
				SQLtype=type;
				bean.setSQLType(SQLtype);
			}
			String mandatory="";
			mandatory = ((ModifyAttributeForm)form).getAMandatory();
			bean.setMandatory(mandatory);
			String defaultValue = null;
			if (mandatory.equals("Y")){
				defaultValue = ((ModifyAttributeForm)form).getADefault();
				if (!type.equals("lookup")){
					bean.setDefaultValue(defaultValue);
				} else {
					int adl =  ((ModifyAttributeForm)form).getADefaultLookup();
					bean.setDefaultValue(adl+"");
				}
			} 
			String basedsp = ((ModifyAttributeForm)form).getBaseDSP();
			String base;
			if (basedsp!=null && basedsp.equals("on")){
				base = "true";
			} else {
				base = "false";
			}
			bean.setBaseDSP(base);
			String status = ((ModifyAttributeForm)form).getAStatus();
			bean.setStatus(status);
			try { // try
				ok = CMDB.modifyAttribute(tabname,newname,bean);
			} catch (SQLException e){
				ok = false;
				err = new ErrorBean("modifyattribute.jsp",e);
			}
		} else { // read mode
			String comment = ((ModifyAttributeForm)form).getAComment(); 
			String aName = ((ModifyAttributeForm)form).getName(); 
			String description = ((ModifyAttributeForm)form).getADescription();
			String basedsp = ((ModifyAttributeForm)form).getBaseDSP();
			if (basedsp!=null && basedsp.equals("on")){
				basedsp = "true";
			} else {
				basedsp = "false";
			}
			System.out.println(comment);
			String st="";
			if (comment.indexOf("DESCR:")!=-1){
				st = comment.substring(comment.indexOf("DESCR:"));
				if (st.indexOf("|")!=-1){
					st = st.substring(0,st.indexOf("|"));
				} 
				comment = comment.replace(st,"DESCR: "+description);
			} else {
				comment += "|DESCR: "+description;
			}
			if (comment.indexOf("BASEDSP:")!=-1){
				st = comment.substring(comment.indexOf("BASEDSP:"));
				if (st.indexOf("|")!=-1){
					st = st.substring(0,st.indexOf("|"));
				} 
				comment = comment.replace(st,"BASEDSP: "+basedsp);
			} else {
				comment += "|BASEDSP: "+basedsp;
			}
			try {
				ok = CMDB.modifyAttributeComment(tabname,aName,comment);
			} catch (SQLException e){
				ok = false;
				err = new ErrorBean("modifyattribute.jsp",e);
			}
		}
		System.out.println("ok="+ok);
		if (ok){
			System.out.println("Tabella modificata");
			String close="ok";
			request.getSession().setAttribute("close",close);
			return mapping.findForward("modify");
		} else {
			System.out.println("Tabella non modificata " + tabname);
			request.getSession().setAttribute("error",err);
			return mapping.findForward("error");
		}
	} // end action
	
	
	public ActionForward addType(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		String classname = ((ModifyAttributeForm)form).getClassName();
		String type = ((ModifyAttributeForm)form).getAType();
		System.out.println("**MODIFYATTRIBUTEFORM ADDTYPE**");
		DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		CMDBlookup LOOKUP = new CMDBlookup(db);
		if (type.equals("lookup")){ // getting default fro this type
			String lookup = ((ModifyAttributeForm)form).getALookup();
			LookupBean lb = null;
			Vector lookupVector = null;
			if (lookup!=null){
				try {
					lookupVector = LOOKUP.selectLookupByType(lookup);
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			if (lookupVector!= null && lookupVector.size()>0){
				lb = (LookupBean)lookupVector.elementAt(0);
				((ModifyAttributeForm)form).setADefault(lb.getDescription());
				((ModifyAttributeForm)form).setADefaultLookup(lb.getId());
				Enumeration en = lookupVector.elements();
				while(en.hasMoreElements()){
					lb = (LookupBean)en.nextElement();
					if (lb.isDefaultValue()){
						((ModifyAttributeForm)form).setADefault(lb.getDescription());
						((ModifyAttributeForm)form).setADefaultLookup(lb.getId());
						break;
					}
				}
			}
		}
		request.getSession().setAttribute("class",classname); // lo salvo nella sessione
		return mapping.findForward("addType");
	}
	
	public ActionForward addDefault(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		String classname = ((ModifyAttributeForm)form).getClassName();
		String type = ((ModifyAttributeForm)form).getAType();
		System.out.println("**MODIFYATTRIBUTEFORM ADDDEFAULT**");
		DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		CMDBlookup LOOKUP = new CMDBlookup(db);
		if (type.equals("lookup")){ // getting default fro this type
			String lookup = ((ModifyAttributeForm)form).getALookup();
			LookupBean lb = null;
			Vector lookupVector = null;
			if (lookup!=null){
				try {
					lookupVector = LOOKUP.selectLookupByType(lookup);
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			if (lookupVector!= null){
				lb = (LookupBean)lookupVector.elementAt(0);
				((ModifyAttributeForm)form).setADefault(lb.getDescription());
				((ModifyAttributeForm)form).setADefaultLookup(lb.getId());
				Enumeration en = lookupVector.elements();
				while(en.hasMoreElements()){
					lb = (LookupBean)en.nextElement();
					if (lb.isDefaultValue()){
						((ModifyAttributeForm)form).setADefault(lb.getDescription());
						((ModifyAttributeForm)form).setADefaultLookup(lb.getId());
						break;
					}
				}
			}
		}
		request.getSession().setAttribute("class",classname); // lo salvo nella sessione
		return mapping.findForward("addDefault");
	}
	public ActionForward loadDefaultLookup(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		String classname = ((ModifyAttributeForm)form).getClassName();
		String type = ((ModifyAttributeForm)form).getAType();
		System.out.println("**MODIFYATTRIBUTEFORM LOADDEFAULTLOOKUP**");
		DBService db = (DBService)servlet.getServletContext().getAttribute("db");
		CMDBlookup LOOKUP = new CMDBlookup(db);
		if (type.equals("lookup")){ // getting default fro this type
			String lookup = ((ModifyAttributeForm)form).getALookup();
			LookupBean lb = null;
			Vector lookupVector = null;
			if (lookup!=null){
				try {
					lookupVector = LOOKUP.selectLookupByType(lookup);
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			if (lookupVector!= null){
				lb = (LookupBean)lookupVector.elementAt(0);
				((ModifyAttributeForm)form).setADefault(lb.getDescription());
				((ModifyAttributeForm)form).setADefaultLookup(lb.getId());
				Enumeration en = lookupVector.elements();
				while(en.hasMoreElements()){
					lb = (LookupBean)en.nextElement();
					if (lb.isDefaultValue()){
						((ModifyAttributeForm)form).setADefault(lb.getDescription());
						((ModifyAttributeForm)form).setADefaultLookup(lb.getId());
						break;
					}
				}
			}
		}
		request.getSession().setAttribute("class",classname); // lo salvo nella sessione
		return mapping.findForward("addDefault");
	}

} // end of class
