package cmdbuild.db;


import java.sql.*;
import java.util.*;

import javax.servlet.ServletException;
import javax.sql.DataSource;
import org.apache.struts.action.*;
import org.apache.struts.config.DataSourceConfig;
import org.apache.struts.config.ModuleConfig;
import org.postgresql.ds.PGPoolingDataSource;
//import org.apache.commons.dbcp.*;
import org.apache.struts.action.ActionServlet;

public class DBService implements PlugIn {

	
	protected ActionServlet servlet;
	private PGPoolingDataSource dataSource;
	private String debug="";
	
	public void init(ActionServlet servlet, ModuleConfig config) throws ServletException {
		this.servlet = servlet;
		this.servlet.getServletContext().setAttribute("db",this);

		// getting database informations from struts-config.xml
		DataSourceConfig dsc = config.findDataSourceConfig("cmdbSource");
		Map hm = dsc.getProperties();
		String databaseDriver = (String)hm.get("driverClassName");
		String url = (String)hm.get("url");
		url = url.substring(url.indexOf("//")+2);
		String serverName = url.substring(0,url.indexOf("/"));
		String databaseName = url.substring(url.lastIndexOf("/")+1);
		String user =(String)hm.get("username");
		String password = (String)hm.get("password");
		String maxCount = (String)hm.get("maxCount");
		int maxConnections = Integer.parseInt(maxCount); 
		debug="driver="+databaseDriver+" serverName="+serverName+" databaseName="+databaseName+" user="+user+" password="+password+" maxCount="+maxCount;
		
		try {
			Class.forName(databaseDriver);
		} catch( Exception ex ) {
			ex.printStackTrace();
		}
		dataSource = new PGPoolingDataSource();
		dataSource.setDataSourceName("A Data Source");
		dataSource.setServerName(serverName);  
		dataSource.setDatabaseName(databaseName);
		dataSource.setUser(user);
		dataSource.setPassword(password); 
		dataSource.setMaxConnections(maxConnections);

		/*
		try {
			Class.forName("org.postgresql.Driver");
		} catch( Exception ex ) {
			ex.printStackTrace();
		}
		dataSource = new PGPoolingDataSource();
		dataSource.setDataSourceName("A Data Source");
		//dataSource.setServerName("192.168.1.19");  
		dataSource.setServerName("localhost");  
		dataSource.setDatabaseName("cmdb-dcl");
		dataSource.setUser("postgres");
		dataSource.setPassword("postgres"); // h
		//dataSource.setPassword(""); // w
		dataSource.setMaxConnections(50);
		*/
	}
	
	public DBService() {
		super();
		// TODO Auto-generated constructor stub
	}

	public DBService(PGPoolingDataSource dataSource) {
		super();
		// TODO Auto-generated constructor stub
		this.dataSource = dataSource;
	}

	public Connection getConnection() {
		try {
			if ( dataSource == null ) {
				System.out.println("GET_CONNECTION(): dataSouce NULL");
			}
			return dataSource.getConnection();
		} catch (SQLException ex){
			ex.printStackTrace();
			return null;
		}
	}
	public static void close(ResultSet res, Statement stm, Connection con){
		try {
			if (res != null){
				res.close();
			}
			if (stm != null){
				stm.close();
			}
			if (con != null){
				con.close();
			}					

		} catch (SQLException ex){
			ex.printStackTrace();	        
		}
	}
	public void destroy() {
		
	}
	public String getDebug() {
		return debug;
	}
	public void setDebug(String debug) {
		this.debug = debug;
	}
	public DataSource getDataSource() {
		return dataSource;
	}
	public void setDataSource(PGPoolingDataSource dataSource) {
		this.dataSource = dataSource;
	}
	

} // end of class
