package cmdbuild.elements;

import cmdbuild.collection.SecurityBean;
import cmdbuild.db.DBService;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Enumeration;
import java.util.Vector;

public class CMDBgroup extends CMDBclass {

	public CMDBgroup() {
		super();
		// TODO Auto-generated constructor stub
	}

	public CMDBgroup(DBService db) {
		super();
		// TODO Auto-generated constructor stub
		this.db = db;
	}

	// *********
	// **group**
	// *********
	public boolean createGroup(SecurityBean sb) throws SQLException {
		boolean result = false;
		Statement stm = null;
		ResultSet rs = null;
		String query = "INSERT INTO \"Role\" (\"Description\",\"Administrator\",\"Status\") VALUES ('"+sb.getGroup()+"',"+sb.isAdministrator()+",'A'); ";
		System.out.println("Query CREATEGROUP="+query);
		Connection con = db.getConnection();
		try {
			if ( con != null ) {
				stm = con.createStatement();
				stm.executeUpdate(query);
				result = true;
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally {
			DBService.close(rs, stm, con);
		}
		return result;
	}
	public  boolean addPolicy(SecurityBean sb) throws SQLException {
		boolean result = false;
		Statement stm = null;
		ResultSet rs = null;
		Connection con = db.getConnection();
		String query = "INSERT INTO \"Grant\" (\"IdClass\",\"IdRole\",\"Mode\") VALUES ("+sb.getClassId()+","+sb.getGroupId()+",'"+sb.getMode()+"'); ";
		System.out.println("Query ADDPOLICY="+query);
		try {
			if ( con != null ) {
				stm = con.createStatement();
				stm.executeUpdate(query);
				result = true;
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally {
			DBService.close(rs, stm, con);
		}
		return result;
	}
	public boolean modifyPolicy(Vector policyVector) throws SQLException {
		boolean result = false;
		Statement stm = null;
		Connection con = db.getConnection();
		if ( con != null ){
			stm = con.createStatement();
		}
		ResultSet rs = null;
		SecurityBean sb = null;
		String query = "";
		Enumeration en = policyVector.elements();
		while(en.hasMoreElements()){
			sb = (SecurityBean)en.nextElement();
			query = "UPDATE \"Grant\" SET \"Mode\"='"+sb.getMode()+"' WHERE \"IdRole\"="+sb.getGroupId()+" AND \"IdClass\"='"+sb.getClassId()+"'; ";
			System.out.println("Query MODIFYPOLICY="+query);
			stm.addBatch(query);
		}
		try {
			if ( con != null ) {
				stm.executeBatch();
				result = true;
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally {
			DBService.close(rs, stm, con);
		}
		return result;
	}
	public  boolean removePolicy(SecurityBean sb) throws SQLException {
		boolean result = false;
		Statement stm = null;
		ResultSet rs = null;
		Connection con = db.getConnection();
		String query = "DELETE FROM \"Grant\" WHERE \"IdRole\"="+sb.getGroupId()+" AND \"IdClass\"="+sb.getClassId()+"; ";
		System.out.println("Query ADDPOLICY="+query);
		try {
			if ( con != null ) {
				stm = con.createStatement();
				stm.executeUpdate(query);
				result = true;
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally {
			DBService.close(rs, stm, con);
		}
		return result;
	}
	public Vector selectPolicyByGroup(String group) throws SQLException {
		Vector policyVector = new Vector();
		SecurityBean sb = null;
		ResultSet rs = null;
		PreparedStatement stm = null;
		String query = "SELECT \"Id\",\"Description\",\"Username\",\"Password\",\"Status\",\"Group\",\"GroupId\",\"Administrator\",\"ClassId\",\"ClassName\",\"Mode\" FROM cmdbpolicycatalog WHERE \"Group\"='"+group+"' ";
		System.out.println("Query SELECTPOLICYBYGROUP="+query);
		Connection con = db.getConnection();
		try {
			if ( con != null ) {
				stm = con.prepareStatement(query);
				rs = stm.executeQuery();
				while( rs.next() ) {
					sb = setSecurityObject(rs);
					policyVector.add(sb);
				}
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally {
			DBService.close(rs, stm, con);
		}
		return policyVector;
	}
	public Vector selectAllGroup() throws SQLException {
		Vector policyVector = new Vector();
		SecurityBean sb = null;
		ResultSet rs = null;
		PreparedStatement stm = null;
		String query = "";
		query = "SELECT id,name,administrator,classname,classid,mode FROM cmdbgroupcatalog";
		System.out.println("Query SELECTALLGROUP="+query);
		Connection con = db.getConnection();
		try {
			if ( con != null ) {
				stm = con.prepareStatement(query);
				rs = stm.executeQuery();
				while( rs.next() ) {
					sb = new SecurityBean();
					sb.setGroupId(rs.getInt(1));
					sb.setGroup(rs.getString(2));
					sb.setAdministrator(rs.getBoolean(3));
					sb.setClassName(rs.getString(4));
					sb.setClassId(rs.getInt(5));
					sb.setMode(rs.getString(6));
					policyVector.add(sb);
				}
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally {
			DBService.close(rs, stm, con);
		}
		return policyVector;
	}
	public Vector selectGroupByName(String group) throws SQLException {
		Vector policyVector = new Vector();
		SecurityBean sb = null;
		ResultSet rs = null;
		PreparedStatement stm = null;
		String query = "";
		query = "SELECT id,name,administrator,classname,classid,mode FROM cmdbgroupcatalog WHERE name='"+group+"' ";
		query +="";
		System.out.println("Query SELECTGROUPBYNAME="+query);
		Connection con = db.getConnection();
		try {
			if ( con != null ) {
				stm = con.prepareStatement(query);
				rs = stm.executeQuery();
				while( rs.next() ) {
					sb = new SecurityBean();
					sb.setGroupId(rs.getInt(1));
					sb.setGroup(rs.getString(2));
					sb.setAdministrator(rs.getBoolean(3));
					sb.setClassName(rs.getString(4));
					sb.setClassId(rs.getInt(5));
					sb.setMode(rs.getString(6));
					policyVector.add(sb);
				}
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally {
			DBService.close(rs, stm, con);
		}
		return policyVector;
	}

	
	/**************************/
	/* USEFUL SETTING METHOTS */
	/**************************/

	private SecurityBean setSecurityObject(ResultSet rs) {
		SecurityBean bean = new SecurityBean();		
		try {
			bean.setId(rs.getInt(1));
			bean.setDescription(rs.getString(2));
			bean.setUsername(rs.getString(3));
			bean.setPassword(rs.getString(4));
			bean.setStatus(rs.getString(5));
			bean.setGroup(rs.getString(6));
			bean.setGroupId(rs.getInt(7));
			bean.setAdministrator(rs.getBoolean(8));
			bean.setClassId(rs.getInt(9));
			bean.setClassName(rs.getString(10));
			bean.setMode(rs.getString(11));
		} catch (SQLException e) {
			e.printStackTrace();
		}		
		return bean;
	}

} // end of class
