package cmdbuild.elements;

import cmdbuild.db.DBService;
import cmdbuild.collection.ClassBean;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Collections;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.StringTokenizer;
import java.util.Vector;

public class CMDBmenu {

	private DBService db;
	
	private String path;
	private Vector levels = new Vector(); 
	private Vector level;
	private Vector HTMLlevels = new Vector();
	private Vector HTMLlevel;
	private Vector palevVector = new Vector();
	private Hashtable menu=new Hashtable();
	
	public CMDBmenu() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	public CMDBmenu(DBService db) {
		super();
		// TODO Auto-generated constructor stub
		this.db = db;
	}

	//	real constructor used
	public CMDBmenu(DBService db, String path, String menuType) {
		super();
		this.path = path;
		this.db = db;
		System.out.println("**MENU**");
		// getting the menu from database
		try {
			this.selectMenu();  
		} catch (SQLException e1) {
			// TODO Auto-generated catch block
			System.out.println("Error! Can't get the menu from database");
			e1.printStackTrace();
		}  
		// TODO Auto-generated constructor stub
		//System.out.println("Path="+path);
		String mtok="";
		int mlevel=0;
		ClassBean men = null;
		Vector levelCleaned = null; 
		// creating the menu
		if (path==null || path.equals("")){ // base level
			try {
				level = selectMenu("Class");
				// searching for duplicates
				Enumeration enim = level.elements();
				ClassBean cb = null;
				ClassBean oldcb = null;
				Hashtable ht = new Hashtable();
				while (enim.hasMoreElements()){
					cb = (ClassBean)enim.nextElement();
					/*
					// first level don't show tips, otherwise delete the next line
					cb.setDescription("");
					*/
					if (!ht.containsKey(cb.getName())){
						ht.put(cb.getName(),cb);
					} else {
						oldcb = (ClassBean)ht.get(cb.getName());
						String desc = oldcb.getDescription()+"/"+cb.getDescription();
						//System.out.println("menu: desc="+desc);
						oldcb.setDescription(desc);
					}
				}
				Enumeration enime = ht.elements();
				// sorting by name
				LinkedList orderedCollection = new LinkedList();
				while (enime.hasMoreElements()){
					cb = (ClassBean)enime.nextElement();
					orderedCollection.add(cb.getName()); // adding only name
				}
				Collections.sort(orderedCollection);
				Iterator it = orderedCollection.iterator();
				levelCleaned = new Vector();
				String name =  "";
				while (it.hasNext()){
					name = (String)it.next();
					cb = (ClassBean)ht.get(name);
					levelCleaned.add(cb);
				}
				level = levelCleaned;
				levels.insertElementAt(level,0);
			} catch (SQLException e){
				System.out.println("Errore SQL:"+e);
			}
		} else { // more levels
			// first level (mlevel=0)
			try {
				level = selectMenu("Class");
			} catch (SQLException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
			// searching for duplicates
			Enumeration enim = level.elements();
			ClassBean cb = null;
			ClassBean oldcb = null;
			Hashtable ht = new Hashtable();
			while (enim.hasMoreElements()){
				cb = (ClassBean)enim.nextElement();
				if (!ht.containsKey(cb.getName())){
					ht.put(cb.getName(),cb);
				} else {
					oldcb = (ClassBean)ht.get(cb.getName());
					String desc = oldcb.getDescription()+"/"+cb.getDescription();
					//System.out.println("menu: desc="+desc);
					oldcb.setDescription(desc);
					//ht.put(oldcb.getName(),oldcb);
				}
			}
			Enumeration enime = ht.elements();
			// sorting by name
			LinkedList orderedCollection = new LinkedList();
			while (enime.hasMoreElements()){
				cb = (ClassBean)enime.nextElement();
				orderedCollection.add(cb.getName()); // adding only name
			}
			Collections.sort(orderedCollection);
			Iterator it = orderedCollection.iterator();
			levelCleaned = new Vector();
			String name =  "";
			while (it.hasNext()){
				name = (String)it.next();
				cb = (ClassBean)ht.get(name);
				levelCleaned.add(cb);
			}
			level = levelCleaned;
			levels.insertElementAt(level,0);
			mlevel = 1;
			StringTokenizer tok = new StringTokenizer(path,"A",false);
			while (tok.hasMoreTokens()){
				mtok = tok.nextToken();
				int mtokn = Integer.parseInt(mtok);
				//System.out.println("mlevel-1="+(mlevel-1));
				level = (Vector)levels.elementAt(mlevel-1);
				//System.out.println("mtok="+mtok+" mtokn="+mtokn);
				//System.out.println("level.size="+level.size());
				if (level!=null && level.size()>0 && mtokn<level.size()){
					men = (ClassBean)level.elementAt(mtokn);
					try {
						level = selectMenu(men.getName());
					} catch (SQLException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
					// searching for duplicates
					enim = level.elements();
					cb = null;
					oldcb = null;
					ht = new Hashtable();
					while (enim.hasMoreElements()){
						cb = (ClassBean)enim.nextElement();
						if (!ht.containsKey(cb.getName())){
							ht.put(cb.getName(),cb);
						} else {
							oldcb = (ClassBean)ht.get(cb.getName());
							String desc = oldcb.getDescription()+"/"+cb.getDescription();
							//System.out.println("menu: desc="+desc);
							oldcb.setDescription(desc);
						}
					}
					enime = ht.elements();
					// sorting by name
					orderedCollection = new LinkedList();
					while (enime.hasMoreElements()){
						cb = (ClassBean)enime.nextElement();
						orderedCollection.add(cb.getName()); // adding only name
					}
					Collections.sort(orderedCollection);
					it = orderedCollection.iterator();
					levelCleaned = new Vector();
					name =  "";
					while (it.hasNext()){
						name = (String)it.next();
						cb = (ClassBean)ht.get(name);
						levelCleaned.add(cb);
					}
					level = levelCleaned;
					levels.insertElementAt(level,mlevel);
					mlevel++;
				}
			} // end fof while
		} // end of else
		//stampa(levels);
		// linking path
		StringTokenizer tok = new StringTokenizer(path,"A",false);
		palevVector.add(""); // first level (0)
		String newpal;
		int i = 1;
		while (tok.hasMoreTokens()){
			mtok = tok.nextToken();
			newpal = palevVector.elementAt(i-1)+mtok+"A";
			palevVector.add(newpal); // added in position i
			i++;
		}
		if (menuType.equals("schema")){
			doHTMLSch();
		} else if(menuType.equals("management")){
			doHTMLMan();
		}
		//stampa(levels);
		//stampaHTML(HTMLlevels);
	}

	// ********
	// **menu**
	// ********
	
	public void selectMenu() throws SQLException {
		ResultSet rs = null;
		PreparedStatement stm = null;
		ClassBean cb = null;
		String query = "SELECT parent,parentdescription,child,childdescription FROM navigationtree";
		System.out.println("Query SELECTMENU="+query);
		Connection con = db.getConnection();
		String par = "";
		Vector vett = null;
		try {
			if ( con != null ) {
				stm = con.prepareStatement(query);
				rs = stm.executeQuery();
				while ( rs.next() ) {
					par = rs.getString(1);
					if (!menu.containsKey(par)){
						cb = new ClassBean();
						cb.setName(rs.getString(3));
						cb.setDescription(rs.getString(4));
						vett = new Vector();
						//System.out.println("adding child "+cb.getName()+" for "+par);
						vett.add(cb);
						menu.put(par,vett);
					} else {
						vett = (Vector)menu.get(par);
						cb = new ClassBean();
						cb.setName(rs.getString(3));
						cb.setDescription(rs.getString(4));
						//System.out.println("adding child "+cb.getName()+" for "+par);
						vett.add(cb);
						menu.put(par,vett);
					}
				}
			}
		} catch( SQLException ex ) {
			throw ex;
		} finally {
			DBService.close(rs, stm, con);
		}
	}
	public Vector selectMenu(String name) throws SQLException {
		Vector vett = new Vector();
		if (menu.containsKey(name)){
			vett = (Vector)menu.get(name);
		}
		return vett;
	}
	
	public void doHTMLSch() {
		ClassBean item;
		String itemLink;
		for (int i=0; i<levels.size();i++){
			level = (Vector)levels.elementAt(i);
			HTMLlevel = new Vector();
			Enumeration enu = level.elements();
			int step = 0;
			while (enu.hasMoreElements()){
				item = (ClassBean)enu.nextElement();
				itemLink= "&nbsp;<a href=\"class.jsp?class="+item.getName()+"&mode=show&disabled=true&m="+palevVector.elementAt(i)+step+"A\" class=\"menu\" alt=\""+item.getDescription()+"\" title=\""+item.getDescription()+"\"><img src=\"images/punto_chiuso.gif\" hspace=\"3\">"+item.getDescription()+"</a><br/>";
				HTMLlevel.add(itemLink);
				step++;
			}
			HTMLlevels.add(HTMLlevel);
			//System.out.println("HTMLlevels.size="+HTMLlevels.size());
		} // end for
	} // end method

	public void doHTMLMan() {
		ClassBean item;
		String itemLink;
		for (int i=0; i<levels.size();i++){
			level = (Vector)levels.elementAt(i);
			HTMLlevel = new Vector();
			Enumeration enu = level.elements();
			int step = 0;
			while (enu.hasMoreElements()){
				item = (ClassBean)enu.nextElement();
				itemLink= "&nbsp;<a href=\"search.jsp?page=1&class="+item.getName()+"&mode=show&m="+palevVector.elementAt(i)+step+"A\" class=\"menu\" alt=\""+item.getDescription()+"\" title=\""+item.getDescription()+"\"><img src=\"images/punto_chiuso.gif\" hspace=\"3\">"+item.getDescription()+"</a><br/>";
				HTMLlevel.add(itemLink);
				step++;
			}
			HTMLlevels.add(HTMLlevel);
			//System.out.println("HTMLlevels.size="+HTMLlevels.size());
		} // end for
	} // end method
	
	public String getMenu(){
		String HTMLtext = "";
		String head = "<div class=\"indent\">";
		String foot = "</div>";
		String change;
		Vector HTMLvector= new Vector();
		Vector v1;
		Vector v2;
		String step = "";
		int pos;
		// creating a unique vector
		if (path == null || path.equals("")){
			HTMLvector = (Vector)HTMLlevels.elementAt(0);
		} else {
			StringTokenizer tok = new StringTokenizer(path,"A",false);
			int numlevel = 0 ;
			int totalLevels = 1;
			Hashtable ht = new Hashtable();
			while (tok.hasMoreTokens()){
				step = tok.nextToken();
				ht.put(numlevel+"",step); // level / point to insert vector
				//System.out.println("numlevel="+numlevel+" step="+step);
				numlevel++;
				totalLevels++;
			}
			int lev = totalLevels-1;
			//System.out.println("lev="+lev+"HTMLlevels.size="+HTMLlevels.size());
			while (lev>0 && lev<HTMLlevels.size()){
				v1 = (Vector)HTMLlevels.elementAt(lev-1); // before last
				v2 = (Vector)HTMLlevels.elementAt(lev); // before last
				//System.out.println( " v1 point at "+(lev-1)+" v2 point at "+lev);
				v2.add(foot); // </div>
				pos = Integer.parseInt( (String)ht.get((lev-1)+"") ) ;
				//System.out.println( "prev lev="+ ((String)ht.get((lev-1)+""))+" where="+pos );
				// changing icon
				change = (String)v1.elementAt(pos);
				v1.remove(pos); // punto_chiuso.gif
				change = change.replaceFirst("punto_chiuso.gif","punto_aperto.gif");
				v1.insertElementAt(change,pos);
				v1.insertElementAt(head,pos+1); // <div class="indent">
				v1.addAll(pos+2,v2);
				HTMLlevels.remove(lev);
				HTMLlevels.setElementAt(v1,lev-1);
				lev--;
			}
			HTMLvector = (Vector)HTMLlevels.elementAt(0);
		}
		// creating HTML
		Enumeration enu = HTMLvector.elements();
		String str;
		while (enu.hasMoreElements()){
			str = (String)enu.nextElement();
			HTMLtext += str+"\n";
		}
		return HTMLtext;
	}

	// used for debugging
	public void stampa(Vector vett){ // vett is a vector of vectors
		System.out.println("--- Vector levels ---");
		Enumeration en = vett.elements();
		Vector lev = null;
		ClassBean item;
 		while (en.hasMoreElements()){
			lev = (Vector)en.nextElement();
			Enumeration enu = lev.elements();
			while(enu.hasMoreElements()){
				item = (ClassBean)enu.nextElement();
				System.out.println(item.getName());
			}
			System.out.println("---");
		}
	}

	// used for debugging
	public void stampaHTML(Vector vett){ // vett is a vector of vectors
		System.out.println("--- Vector levels ---");
		Enumeration en = vett.elements();
		Vector lev = null;
		String item;
 		while (en.hasMoreElements()){
			lev = (Vector)en.nextElement();
			Enumeration enu = lev.elements();
			while(enu.hasMoreElements()){
				item = (String)enu.nextElement();
				System.out.println(item);
			}
			System.out.println("---");
		}
	}

} // end of class
