package cmdbuild.utils;

import java.security.spec.KeySpec;
import java.security.spec.AlgorithmParameterSpec;
import java.security.InvalidAlgorithmParameterException;
import java.security.NoSuchAlgorithmException;
import java.security.InvalidKeyException;
import java.security.spec.InvalidKeySpecException;

import javax.crypto.Cipher;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.SecretKey;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.PBEKeySpec;
import javax.crypto.spec.PBEParameterSpec;

public class SecurityEncrypter {

	Cipher ecipher;
	Cipher dcipher;

	public SecurityEncrypter() {
		super();
        // 8-bytes Salt
        byte[] salt = {
            (byte)0xA9, (byte)0x9B, (byte)0xC8, (byte)0x32,
            (byte)0x56, (byte)0x34, (byte)0xE3, (byte)0x03
        };
        int uznig = 0x19d15ea; 
        String pPh = Integer.toString(uznig);
        // Iteration count
        int iterationCount = 19;

        try {

            KeySpec keySpec = new PBEKeySpec(pPh.toCharArray(), salt, iterationCount);
            SecretKey key = SecretKeyFactory.getInstance("PBEWithMD5AndDES").generateSecret(keySpec);

            ecipher = Cipher.getInstance(key.getAlgorithm());
            dcipher = Cipher.getInstance(key.getAlgorithm());

            // Prepare the parameters to the cipthers
            AlgorithmParameterSpec paramSpec = new PBEParameterSpec(salt, iterationCount);

            ecipher.init(Cipher.ENCRYPT_MODE, key, paramSpec);
            dcipher.init(Cipher.DECRYPT_MODE, key, paramSpec);

        } catch (InvalidAlgorithmParameterException e) {
            System.out.println("EXCEPTION: InvalidAlgorithmParameterException");
        } catch (InvalidKeySpecException e) {
            System.out.println("EXCEPTION: InvalidKeySpecException");
        } catch (NoSuchPaddingException e) {
            System.out.println("EXCEPTION: NoSuchPaddingException");
        } catch (NoSuchAlgorithmException e) {
            System.out.println("EXCEPTION: NoSuchAlgorithmException");
        } catch (InvalidKeyException e) {
            System.out.println("EXCEPTION: InvalidKeyException");
        }
		// TODO Auto-generated constructor stub
	}

	public SecurityEncrypter(SecretKey key, String algorithm) {
		try {
			ecipher = Cipher.getInstance(algorithm);
	        dcipher = Cipher.getInstance(algorithm);
	        ecipher.init(Cipher.ENCRYPT_MODE, key);
	        dcipher.init(Cipher.DECRYPT_MODE, key);
	    } catch (NoSuchPaddingException e) {
	        System.out.println("EXCEPTION: NoSuchPaddingException");
	    } catch (NoSuchAlgorithmException e) {
	        System.out.println("EXCEPTION: NoSuchAlgorithmException");
	    } catch (InvalidKeyException e) {
	        System.out.println("EXCEPTION: InvalidKeyException");
	    }
	}

	public SecurityEncrypter(String passPhrase) {

	        // 8-bytes Salt
	        byte[] salt = {
	            (byte)0xA9, (byte)0x9B, (byte)0xC8, (byte)0x32,
	            (byte)0x56, (byte)0x34, (byte)0xE3, (byte)0x03
	        };

	        // Iteration count
	        int iterationCount = 19;

	        try {

	            KeySpec keySpec = new PBEKeySpec(passPhrase.toCharArray(), salt, iterationCount);
	            SecretKey key = SecretKeyFactory.getInstance("PBEWithMD5AndDES").generateSecret(keySpec);

	            ecipher = Cipher.getInstance(key.getAlgorithm());
	            dcipher = Cipher.getInstance(key.getAlgorithm());

	            // Prepare the parameters to the cipthers
	            AlgorithmParameterSpec paramSpec = new PBEParameterSpec(salt, iterationCount);

	            ecipher.init(Cipher.ENCRYPT_MODE, key, paramSpec);
	            dcipher.init(Cipher.DECRYPT_MODE, key, paramSpec);

	        } catch (InvalidAlgorithmParameterException e) {
	            System.out.println("EXCEPTION: InvalidAlgorithmParameterException");
	        } catch (InvalidKeySpecException e) {
	            System.out.println("EXCEPTION: InvalidKeySpecException");
	        } catch (NoSuchPaddingException e) {
	            System.out.println("EXCEPTION: NoSuchPaddingException");
	        } catch (NoSuchAlgorithmException e) {
	            System.out.println("EXCEPTION: NoSuchAlgorithmException");
	        } catch (InvalidKeyException e) {
	            System.out.println("EXCEPTION: InvalidKeyException");
	        }
	    }

	    public String encrypt(String str) {
	        try {
	            // Encode the string into bytes using utf-8
	            byte[] utf8 = str.getBytes("UTF8");

	            // Encrypt
	            byte[] enc = ecipher.doFinal(utf8);

	            // Encode bytes to base64 to get a string
	            return new sun.misc.BASE64Encoder().encode(enc);

	        } catch (Exception e) {
	        }
	        return null;
	    }

	    public String decrypt(String str) {
	        try {
	            // Decode base64 to get bytes
	            byte[] dec = new sun.misc.BASE64Decoder().decodeBuffer(str);
	            // Decrypt
	            byte[] utf8 = dcipher.doFinal(dec);
	            // Decode using utf-8
	            return new String(utf8, "UTF8");
	        } catch (Exception e) {
	        } 
	        return null;
	    }


} // end of class
